*COMDECK HISTORY  
 RHFA002  CHANGE DEFINITION OF #FASTFOR# TO THE SAME AS #SLOWFOR# 
          SINCE SYMPL PRODUCES UNRELIABLE FASTLOOP CODE.
          NAD    10/14/81          COMCBEGN 
  
 RHFA050  MODIFY VCP TO EQUATE RA.ACT TO ACTR UNDER NOS.
          NAD    10/21/81          VCP
  
 RHFA052  THIS MOD ADDS CONDITIONAL CODE TO RHF FOR NOS.  IT ENABLES
          HANDLING OF FOUR CHARACTER JOBNAMES, AUTOMATIC STARTUP OF 
          SERVICERS, AND ELIMINATES CTRL/INFO SET EOJ CONNECT FUNCTION
          CALLS.
          MTE    10/23/81          RHFMSGJ, APPLDSPL, STRTJOB, RHFDATA
                                   NETON, CTRLNFO, OVLYSCN, OVLLDR
  
 RHFA042  WHEN FIP WAS EXECUTING ON NOS, THE SUBSYSTEM NUMBER/QUEUE 
          PRIORITY WAS BEING SET TO BLANKS INSTEAD OF  -2.
          THIS CODE CORRECTS THAT PROBLEM.
          GDM    10/15/81          COMACBF
  
 RHFA053  ADD CALLS TO FTF/FTFS TO NETDBG CONDITIONALLY 
          IF ASSEMBLED WITH PCOMMENT EQUAL TO DEBUG.
          DJR    81/10/27.         FTF     - RHFA053A 
                                   FTFS    - RHFA053B 
                                   FILXFR  - RHFA053C 
                                   COMCPTF - RHFA053D  (PL1L) 
                                   HISTORY - RHFA053E  (PL1L) 
  
 RHFA058  DEFINE RA.ARG AND RA.CCD IN DMPNAD FOR NOS. 
          NAD    10/28/81          DMPNAD 
  
 RHFA004   THE FOLLOWING CHANGES WERE MADE CONCERNING DATA DECLARATION
           TYPES: 
              A NEW TYPE, UH = 0, WAS ADDED. UH IS BINARY DATA WITH 
                  EMBEDDED CONTROL WORDS. IT IS USED WHEN THE REMOTE
                  HOST IS AN I/O COMPATIBLE OPERATING SYSTEM. 
              OLD CZ TYPE WAS DELETED AND OLD C8 WAS REDEFINED TO BE THE
                  THE SAME AS THE OLD CZ.  I.E. C8 NOW MEANS ASCII
                  FILE WITH Z-BYTES FOR END-OF-LINES. 
              A NEW DATA DECLARATION TYPE WAS ADDED, CN, USED ONLY
                  INTERNALLY BY FIP.  CN IS THE FILE STRUCTURE THAT 
                  IS SENT/RECEIVED FROM THE NETWORK DRIVER (NDR).  IT 
                  IS ASCII DATA WITH UNIT SEPARATORS FOR END-OF-LINES.
                  IT IS THE OLD C8. 
              THE APPLICATION IS NOW ONLY ALLOWED TO SPECIFY THE
                  FOLLOWING DATA DECLARATIONS (THEIR REDEFINED VALUES 
                  ARE ALSO SHOWN):  
                        UH = 0
                        UU = 1
                        US = 2
                        C6 = 3
                        C8 = 4
              THE DATA DECLARATION TYPE PLACED IN THE RHF FET ONLY HAS
                  TWO VALUES:  (VALUES CHOSEN IMPACT NDR THE LEAST) 
                        BINARY = 1
                        CODED  = 3
  
  
      GDM        10/12/81          DECKS AFFECTED   IDENT 
                                     COMCCAE       RHFA004A 
                                     COMACBF       RHFA004B 
                                     COMACBX       RHFA004C 
                                     COMACST       RHFA004D 
                                     BUILDFT       RHFA004E 
                                     DOXFR         RHFA004F 
                                     GETCHR        RHFA004G 
                                     NETXFR        RHFA004H 
                                     VALLOCF       RHFA004I 
                                     DDC           RHFA004J 
                                     PHT           RHFA004K 
                                     COMCPTF       RHFA004L 
  
 RHFA043  THIS MOD CORRECTS A TIMING BUG WHICH IS CAUSED BY 
          THE SYMPL COMPILER OPTIMIZING CODE.  THE CODE PUTS
          A NEW ROUTINE IN RHF, NDRRSTR, WHOSE ONLY FUNCTION
          IS TO CLEAR THE NDR FUNCTION COMPLETE FIELD TO RESTART
          NDR.  ALL ROUTINES WHO RESTART NDR MUST CALL THIS 
          FUNCTION AFTER THEY HAVE SET UP THE NDR REQUEST BLOCK.
          GSA    10/23/81          ASGNIP,NADFUNC,NIPCOMP,
                                   NXTNADR,REMCONR,RHFOVL,
                                   NDRRSTR
  
          RHFA043                  ASGNIP,NADFUNC,NIPCOMP,
                                   NXTNADR,REMCONR,RHFOVL 
          NDRRSTR                  NDRRSTR
  
 RHFA046  NDR MUST BE DESIGNED TO HANDLE THE CASE WHERE 
          A USER REQUESTS TO SEND A DATA BLOCK WITHOUT ANY TEXT 
          (A BLOCK WITH JUST A HEADER).  THIS MOD ADDS CODE TO
          OVERLAY 2NW IN NDR TO HANDLE THIS CASE. 
          GSA    10/23/81          NDR
  
 RHFA047  CODE FOR THIS PSR UPDATES THE COMMON PP ROUTINES NDR, 
          RHH, AND NLD ALONG WITH THE APPROPRIATE COMMON DECKS
          SO THAT THEY ARE COMPATIBLE WITH THE NOS FNT PHASE II 
          SYSTEM. 
          GSA    10/25/81          RHH,NDR,NLD,COMCHNRES, 
                                   COMNOSDEF,COMNADCER
  
          RHFA047A                 COMNOSDEF
          RHFA047B                 COMCHNRES
          RHFA047C                 COMNADCER
          RHFA047D                 NDR
          RHFA047E                 NLD
          RHFA047F                 RHH
  
 RHFA048  IN THE COMMON ROUTINE NLD (USED FOR NOS AND NOS/BE) 
          CONDITIONAL CODE MUST BE ADDED SO THAT NLD IGNORES THE
          AUTO RECALL BIT FOR NOS, BECAUSE IT IS NOT POSSIBLE 
          FOR DMPNAD TO CALL NLD WITHOUT RECALL ON A NOS
          OPERATING SYSTEM.  NLD HAS A SPECIAL MECHANISM TO HANDLE
          RESTARTING THE CONTROL POINT. 
          GSA    10/23/81          NLD
  
 RHFA057  THIS MOD ADDS CONDITIONAL CODE TO RHF TO HANDLE THE 
          K DISPLAY FOR NOS.  IT ALSO ADDS THE LOG ERRORS 
          AND CHANNEL FIELDS TO THE PATH DISPLAY.  DOCUMENTATION
          IS ADDED TO QUEUE, DEQUEUE, AND COMRAPL.
          MTE    10/28/81          STARTUP, COMRDSDL, APPLDSPL, IDDSPL, 
                                   PATHDSPL, PATHC, N$CONSL, N$EESET
                                   COMRAPL, COMRNET, DEQUEUE, QUEUE.
  
 RHFA062  HAVE OVLLDR IN RHF SETUP OVERLAY LEVEL NUMBERS IN LDV 
          PARAMETER BLOCK TO PREVENT NOS LDR FROM ATTEMPTING
          EXECUTION OF LOADED OVERLAYS. 
          NAD    10/31/81          WAIT,OVLLDR
  
 RHFA069  MODIFY THE METHOD OF KEEPING TRACK OF THE TIMEOUT 
          INTERVAL TO USE THE LOWER 36 BITS OF THE RTIME MACRO RETURN 
          AND TO USE QUARTER MILLISECONDS AS THE INTERVAL UNIT. 
          DJR    80/11/09          COMCPTF - RHFA069A 
                                   STT     - RHFA069B 
                                   RCT     - RHFA069C 
  
 RHFA070  THIS MOD CORRECTS THE SYSTEM ORGIN TEST FOR NOS AND CORRECTS
          THE SECOND WORD IN THE SFC SF.XWRIT CALL. 
          MTE    11/11/81          COMRSFC, UCPVAL, CTRLNDT 
  
 RHFA071   THIS MOD MODIFIES RHFDATA TO PUT THE ACCESS CODE IN THE PATH 
           ENTRY RATHER THAN IN THE REMOTE NAD ENTRY.  IT ALSO ADDS THE 
           LOG BIT TO THE REMOTE NAD ENTRY. 
           MTE    11/11/81          RHFDATA 
  
 RHFA072  THIS MOD CORRECTS THE MODE ERROR PROBLEM IN MOPUPQS.
          A LINE OF CODE IS ADDED TO DEQUEUE AN ENTRY BEFORE IT IS
          REFERENCED AND POSSIBLY FREED.
          MTE    11/12/81          MOPUPQS
  
 F7436CY  FEATURE MODIFICATIONS FOR REMOTE NAD VALIDATION.
          ADDS 6CV, NEW PP OVERLAY FOR CVL. 
  
          IDENT     PL    DECK
          F7436CW   PL1A  PPSYS, PPTEXT, SCPTEXT (COMMENT LINES ONLY) 
          F7436CX   PL1B  CVL 
          F7436CY   PL1L  COMNADCER 
          F7436CYA  PL1L  COMCHNRES 
          6CV       PL1L  6CV (NEW CVL OVERLAY) 
  
          DPK    11/20/81          COMNADCER, COMNADIO, COMCHNRES 
  
 F5471AL  THIS FEATURE MOD ADDS CODE TO RHF TO AUTOMATICALLY
          LOAD CONTROLWARE IN LOCAL NADS WHEN RHF IS BROUGHT UP.
          GSA    12/01/81           AUTLOAD,STARTUP,COMRNET 
  
 F5471AN  ADDS CODE TO NLD TO TURN THE NAD ON IF THE
          CONTROLWARE LOAD FOR THAT LOCAL NAD WAS SUCCESSFUL. 
          GSA    11/30/81          NLD
  
 RHFA019  THIS MOD PLACES CODE IN RHF TO PROCESS THE IDLE COMMAND.
          GSA    10/22/81          CONTROL,ACTIVE,OVLYSCN,TIMEVNT,
                                   AGENTON,CKOPMSG,SNDSHDM,ASSIGN,
                                   FINDAPL,RHFOVL,COMRFLSH,COMRMEM, 
                                   APPLDISEN
  
 RHFA078  THIS MOD CORRECTS THE TRUNCATED NAD OFF MESSAGE.
          MTE    11/23/81          COMRFLSH 
  
 RHFA079  THIS MOD CORRECTS THE EST FIELD AND THE CH FIELD IN THE 
          PATH DISPLAY. 
          MTE    11/23/81          PATHDSPL 
  
 RHFA080  THIS MOD CORRECTS THE PROBLEM OF THE INVALID COMMAND LINE 
          WIPING OUT THE K-DISPLAY ON NOS.  IT ALSO ADDS LOG T0 THE 
          LIST OF AVAILABLE COMMANDS. 
          MTE    11/23/81          COMRDSDL, CHCMD, ERROR 
  
 RHFA085  THIS MOD CORRECTS THE PROBLEM OF THE CONNECTION ADDRESS RATHER
          THAN THE ACN BEING PUT INTO THE ACN FIELD IN OUTGOING CONTROL 
          MESSAGES. 
          MTE    11/23/81          ACKQ, FCBRKR, FCRSTR 
  
 RHFA090  THIS MOD CORRECTS UCPVAL FOR NOS.  CALLS TO UCPVAL ARE NOW
          MADE WITH THE JOBID NOT JUST THE JOBORD.
          MTE    11/25/81          UCPVAL, NETON$, CTRLNFO
  
 RHA045   THIS PSR ADDS A NEW FUNCTION TO RHH.  THE 
          FUNCTION, 12B, IS USED TO RETURN THE JOBNAME
          OF THE CALLING CP PROGRAM.
          GSA    12/19/81          RHH
  
 RHFA074  THIS MOD FIXES THE UPDATING OF A POINTER
          AFTER A *+* L DISPLAY COMMAND IS RECIEVED.
          DJR    82/01/12.         PATHDSPL 
  
 RHFA099  THIS MOD IS MADE TO ALLOW FTF TO BE COMPATABLE
          WITH NOS.  THE LABEL TSCS IS CHANGED TO TSAC AND
          THE VALUE OF STAT IS CHANGED TO 77B DEFAULT.
          DJR    81/12/15.   HISTORY  RHFA099   (PL91)
                             COMFFTF  RHFA099A  (PL91)
                             FTF      RHFA099B  (PL91)
                             FTFS     RHFA099C  (PL91)
                             HISTORY  RHFA099D  (PL1L)
                             COMCPTF  RHFA099E  (PL1L)
  
 RHFA118  NLD MUST SET ITS INTERNAL FLAG WHEN IT SETS 
          THE NETLOG ACTIVE BIT IN THE EST SO THAT IT 
          WILL CLEAR THE BIT DURING ITS TERMINATION CLEANUP.
          GSA    12/16/81          NLD
  
 RHFA051 FIP DID NOT SUPPORT THE 63 CHARACTER SET FOR C6 ON NOS/BE. 
         RVT    10/22/81    DECKS MODIFIED    IDENT 
                             XFRINIT         RHFA051
  
                            NEW DECKS 
                             CSET63 
                             SETC63 
  
 RHFA066 BUILDFT UN-NECESSARILY CALLS A SUBROUTINE TO PLUG
         A FILE NAME INTO THE RHF FET.  (USED FOR DEBUGGING WHEN
         RHF IS SIMULATED BY CIO.)
         RVT  11/04/81   BUILDFT
  
 F5471CA  ADD CODE TO NDR TO HANDLE THE RHF/NDR 
          COMMUNICATION AREA BEING AT AN ADDRESS GREATER
          THAN 7777B.  THE ADDRESS WILL STILL BE GIVEN
          TO NDR IN THE SAME TWELVE BIT FIELD, BUT IT 
          WILL NOW BE DEFINED AS (COMMUNICATION ADDRESS)/10B. 
          GSA    01/20/82          NDR,COMFETIO 
  
          F5471CAA                 COMFETIO 
          F5471CAB                 NDR
  
 F5471ML  THIS FEATURE IDENT ADDS A NEW PROGRAM TO THE RHF
          SUBSYSTEM.  THE PROGRAM, NETLOG, REPLACES THE OLD 
          NETLOG AS THE MAINTENCE ROUTINE FOR THE NADS.  ALSO 
          A PROC, MLTF, IS ADDED WHICH IS THE CONTROLLING 
          ROUTINE FOR NETLOG.  A COMMON COMPASS ROUTINE, SSJCALL, 
          HAS ALSO BEEN ADDED WHICH IS JUST AN ENTRY POINT, SSJ=, 
          TO BE USED BY THE APPLICATION PROGRAMS FOR NOS. 
          GSA    12/17/81 
  
          DECKNAME      IDENT 
          SSJCALL       SSJCALL 
          MLTF          MLTF
          NETLOG        NETLOG
          GTRHNDT       GTRHNDT 
          GTNDTFL       GTNDTFL 
          LOGLNAD       LOGLNAD 
          LOGRNAD       LOGRNAD 
          LOG$CER       LOG$CER 
          LOG$BML       LOB$BML 
          GET$LOG       GET$LOG 
          COMNCOM       COMNCOM 
          COMNGET       COMNGET 
  
 F5471RG  THIS FEATURE IDENT ADDS CODE TO RHF TO READ THE 
          CONFIGURATION FILE RCFILE CREATED BY RCFGEN.
          MTE    01/15/82          COMRPTRS,RHFDATA,GETFILE,STARTUP,
                                   AUTLOAD,EVNTSCN,UCPREQ,NADREQ
                                   STRTNDR,NDRCOMP,NXTNADR,NADFUNC
                                   UNKNUCP,NOAPLAD,FINDAPL,FREEACN
                                   WAITACN,MOPQACN,NADOFF,SCANPTH,
                                   CONREQN,FINDACN,PATHVAL,REMDAYF
                                   TIMEVNT,CLRPTHR,APPLDISEN,IDDISEN
                                   PATHDISEN,PATHC,APPLDSPL,IDDSPL, 
                                   PATHDSPL,STRTJOB,BATCJOB,COMRNET 
                                   COMRRTN,CONARQR,ASSIGN,ACTIVE
 F7436DR  DMPNAD MODIFICATIONS TO ALLOW DUMPING OF REMOTE NAD.
          ALSO ADDS CVL ERROR CODE TO DAYFILE MESSAGE.
          DPK    01/25/82          DMPNAD 
  
 F7436NR  REMOTE NAD CONTROLWARE LOADING. 
          ADDS NEW NLD FUNCTION (4) - TURN NAD ON AND UP. 
          DPK    01/27/82          NLD
  
 RHFA021  THIS MOD ADDS THE IDLE OVERLAY TO RHF.
          MTE    01/15/82          CONTROL, RHFOVL, IDLE
  
 RHFA077  THIS PSR ADDS CODE TO NDR AND COMDECKS USED 
          BY NDR TO CLEANUP THE HANDLING OF FC/BRK AND
          FC/RST CONTROL MESSAGES.
          GSA    01/27/82          COMNADIO,COM2NQ,COM2NS,
                                   COM3NW,NDR 
  
          RHFA077A                 COMNADIO 
          RHFA077B                 COM2NQ 
          RHFA077C                 COM2NS 
          RHFA077D                 COM3NW 
          RHFA077E                 NDR
  
 RHFA091  DMPNAD LT= PARAMETER SYNTAX CHANGED FROM LT=XX (OCTAL) TO 
          LT=YYYY (BINARY, Y = 0 OR 1). 
          DPK    01/19/82          DMPNAD 
  
 RHFA102  ADD CONDITIONAL CODE TO SUBROUTINE GFL TO SET COMPLETE BIT
          FOR NOS FILINFO MACRO CALL.  CORRECT PTP TO SAVE TIMEOUT
          IN MILLISECONDS RATHER THAN SECONDS.  HAVE SNP RETURN 
          JUMP TO ABT RATHER THAN JUMP. 
          NAD    01/14/82          GFL,PTP,SNP
  
 RHFA151  THIS PSR CHANGES THE FORMATS FOR BML AND CERFILE
          MESSAGES THAT ARE ISSUED BY THE PP ROUTINES IN
          THE RHF SUBSYSTEM.
          GSA    01/12/82          COMNADIO,COMNADCER,NDR 
  
          RHFA151A                 COMNADIO 
          RHFA151B                 COMNADCER
          RHFA151C                 NDR
  
 RHFA152  THIS PSR ADDS CODE TO NDR TO VALIDATE LIDS ON 
          INCOMING CONNECT REQUESTS FOR NOS.
          GSA    01/12/81          COMNOSDEF,NDR
  
          RHFA152A                 COMNOSDEF
          RHFA152B                 NDR
  
 RHFA006  THIS MOD MODIFIES MOPUPQS TO ALSO CHECK THE JOBID 
          WHEN PROCESSING THE UNKNOWNREQ QUEUE. 
          MTE    02/02/82          MOPUPQS
  
 RHFA086  THIS MOD ADDS CODE TO STARTUP TO AUTOMATICALLY INITIATE 
          ANY APPLICATION WHICH HAS THE AUTOSTART AND ENABLED BITS
          SET.
          MTE    02/02/82          STARTUP, AUTSTRT, FINDAPL, RHFOVL
  
 RHFA087  THIS MOD ADDS CODE TO APPLDISEN TO AUTO START AN APPLICATION
          WHEN THE OPERATOR ENABLES IT IF THE AUTO START BIT IS SET.
          MTE    02/02/82          APPLDISEN, RHFOVL
  
 RHFA154  RHF SHOULD NOT USE SID = $RH FOR NOS SPOT JOBS.  THIS 
          MOD CORRECTS RHF. 
          MTE    02/02/82          BATCJOB
  
 RHFA026  THIS MOD ADDS A FLASHING MESSAGE QUEUE TO HANDLE FLASHING 
          MESSAGES THAT NEED TO BE ACKED. 
          MTE    02/02/82          COMRQUE, COMRFLSH, RHFMSG, NADOFF, 
                                   REQCON, CKOPMSG, ACTIVE, COMRMEM 
  
 RHFA063  DMPNAD REQUIRES NOS COMDECK COMCCVL FOR CEVAL MACRO.
          NAD    2/14/82           DMPNAD 
  
 RHFA200  THIS MOD REPLACES THE CHECK FOR A COLON WITH A CHECK FOR
          BINARY ZEROES IN GETCMD AND DELETES THE CALL TO ABORT IN
          DSPL. 
          MTE    02/12/82          GETCMD, DSPL 
  
 RHFA201  RHF MODES OUT IF THE FIRST CHARACTER ENTERED UNDER THE
          L/K DISPLAY IS A SEPARATOR - COMMA, PERIOD, BLANK, OR ZERO. 
          THIS MOD CHANGES RHF TO ISSUE AN INVALID COMMAND MESSAGE
          INSTEAD.
          MTE    02/11/82          GETCMD 
  
 RHFA214  REMOVE CALL TO NETMAC FROM COMCMAC AND PLACE CALLS IN THOSE 
          DECKS WHICH REALLY NEED NETMAC.  THIS GREATLY REDUCES 
          ASSEMBLY TIMES OF MOST COMPASS ROUTINES.
          ADD NOS CONDITIONAL CODE TO COMCMAC TO: 
          - DEFINE NOS/BE RA.XXX SYMBOLS IN TERMS OF NOS XXXR SYMBOLS,
          - PROVIDE NOS/BE CONTRLC AND LOADREQ MACRO DEFINITIONS. 
  
          RHFA214            HISTORY (PL1L) 
          RHFA214A           COMCMAC
          RHFA214B           BKC
          RHFA214C           ECL
          RHFA214D           GMB
          RHFA214E           PMB
          RHFA214F           TNL
          RHFA214G           WLB
          RHFA214H           CMACROS
          RHFA214K           HISTORY (PL91) 
          RHFA214L           FTF
          RHFA214M           FTFS 
          RHFA214N           FILXFR 
  
          NAD    2/14/82     COMCMAC,BKC,ECL,GMB,PMB,TNL,WLB,CMACROS (PL1L) 
                             FTF,FTFS,FILXFR (PL91) 
  
 RHFA227  PARAMETERS FOR SF$REGR WERE PUT IN WRONG WORD FOR NOS 
          IN NETONR.  THIS MOD CORRECTS THAT. 
          MTE    02/11/82          NETONR 
  
 RHFA230  CORRECT RCFGEN PROBLEM CAUSED BY COMPASS REWIND OF
          XTEXT FILE.  ALSO CORRECT NOS SPOT JOB CONTROL STATEMENTS.
          NAD    2/22/82     RCFGEN 
  
 C7436CR  MODIFY SELECT-PATH SUBROUTINE TO REPORT HARDWARE ERRORS.
          MAKES DISCONNECT AND PURGE PATH FUNCTIONS MORE LIKELY TO
          COMPLETE PROPERLY.
          ADD NEW NAD ERROR CODE FOR CONNECT-IN-PROGRESS TIME-OUT.
  
          C7436CR  NLD
          C7436CRA COMNADIO,NDR,6CV 
  
          DPK    02/19/82          NLD,COMNADIO,NDR,6CV 
  
 RHFA014  HARDWARE-UNIQUE-IDENTIFIER (HUI) SET IN NAD EST ENTRY, BYTE 
          C.ESTHUI, WHEN NAD IS TURNED ON AND UP (NLD FUNCTION 4) 
          FOLLOWING LOAD OF LOCAL NAD.
          DPK    02/08/82          NLD
  
 RHFA160  THIS PSR ADDS CODE TO NDR TO HANDLE THE NEW 
          FLAG IN THE NDR/RHF COMMUNICATION AREA THAT 
          WAS ADDED BY PSR RHFA204.  THE FLAG IS USED 
          TO TELL NDR THAT RHF IS MODIFYING THE 
          COMMUNICATION AREA AND THAT NDR SHOULD WAIT 
          UNTIL THE FLAG IS CLEARED.
          GSA    02/23/82          NDR
  
 RHFA233  CSET63 ENTRY POINT ADDED FOR NOS INSTALLATION.
          ( *ENTRY CSET63* REPLACES *CSET63 SUBR =*.) 
          DPK    02/25/82          CSET63 
  
 RHFA204  WHEN RHF IS LOOKING FOR A COPY OF NDR TO ASSIGN A NEW 
          FUNCTION TO, IT MAY USE AN ACTIVE NDR THAT IS CURRENTLY 
          IN AN IDLE LOOP.  THE PROBLEM IS THAT RHF DOES NOT KNOW 
          IF NDR HAS READ UP THE IDLE REQUEST YET, AND RHF MAY
          START CHANGING THE NDR/RHF REQUEST AREA BEFORE NDR HAS
          READ UP THE IDLE REQUEST.  THE PROBLEM IS SOLVED BY 
          ADDING A FLAG IN THE REQUEST AREA TELLING NDR THAT RHF
          IS CHANGING THE REQUEST AREA.  THE MAIN SYMPTOMS
          THAT WERE SEEN INCLUDED ERROR LOGICALS CAUSED 
          BECAUSE NDR WAS PROCESSING A BAD QUEUE ENTRY. 
          GSA    02/23/82          COMRNIP,IDLE,NADREQ, 
                                   STRTNIP,ASGNIP 
  
 F5471QL  FEATURE CODE FOR NOS QTF AND RHF ROUTING TEXT 
          SUPPORT.
  
          RLF/PCH 03/04/82         COMCCAE,COMCDEF
  
 C5471MR  CORRECT *WIDTH DIRECTIVE IN MLTF AND RCFGEN PROCEDURES. 
          NAD    02/05/82          MLTF, RCFGEN 
  
 RHFA215  MODIFY MLTF PROC TO BE USED WITH RHF AUTO-START.
          NAD    2/14/82     MLTF 
  
 RHFA101  WHEN PERFORMING AN SF.LIST FUNCTION CPUMTR MAY NOT
          HAVE COMPLETED THE FUNCTION BEFORE RETURNING CONTROL
          TO THE CALLING PROGRAM.  THIS MOD ADDS CODE TO
          THE SSFREQ ROUTINE IN RHF TO MAKE SURE THE SF.LIST
          COMMAND IS COMPLETE BEFORE RHF GOES ON. 
          MTE    03/10/82          SSFREQ 
  
 RHFA226  CODE FOR THIS PSR CORRECTS A PROBLEM CAUSED BY
          NDR NOT CHECKING FOR A LARGE ENOUGH BUFFER TO HANDLE
          THE CASE OF INPUTING A FULL BLOCK THAT HAS THE EOR
          BIT SET.
          GSA    03/09/82          NDR
  
 F5471CV  ADD CONDITIONAL CODE TO CVL OVERLAY 5CV SO
          THAT IT CAN BE USED ON A NOS SYSTEM.
          GSA    02/02/82          5CV,COMNOSDEF,COMCHNRES
  
          F5471CVA                 COMNOSDEF
          F5471CVB                 COMCHNRES
          5CV                      5CV
  
 RHFA003  THE DEFINITIONS IN COMACBF WERE SPLIT OFF TO FORM A NEW 
          COMMON DECK COMADEF. ALL DECKS WHICH CALL COMACBF WERE CHANGED
          SO THAT THEY NOW CALL COMADEF.  A CONTROL PRESET WAS INSERTED 
          IN NETON.  A DUMMY CALL TO PRSTFIP WAS INSERTED IN NETXFR.
          PRSTFIP WAS CHANGED SO THAT ONLY COMMON BLOCKS USED BY
          THE FIPXFR MODULES ARE PRESET.  THESE CHANGES NOW ALLOW 
          FIP AND FIPXFR MODULES TO BE LOADED WITHOUT LOADER ERRORS,
          FIP-S COMMON BLOCKS GET PRESET WHENEVER NETON IS LOADED,
          AND FIPXFR-S COMMON BLOCKS GET PRESET WHENEVER NETXFR IS
          LOADED.  ALSO THE LENGTH OF THE NETXFR BUFFERS HAS BEEN 
          CHANGED TO IMPROVE NETXFR EFFICIENCY. 
          GDM/EEN  03/10/82          FIP - ZEROWDS (ALL THE FIP DECKS)
  
 F5471FS  REWORK NETWAIT AND NETXFR ALGORITHMS TO IMPROVE 
          FILE TRANSFER PERFORMANCE.  COLLECT STATISTICS ON 
          NUMBER OF CALLS TO FIP ENTRY POINTS AND SSC CALLS 
          TO RHF.  DAYFILE STATISTICS IN NETOFF IF DEBUG ON.
          NETWAIT RESTRUCTURE ALSO PREVENTS PROBLEMS WITH 
          NON-WAIT NETXFR CALLS (SUCH AS FROM QTFI) WHICH 
          ABORTED WITH SSC COMPLETE BIT ALREADY SET ERRORS
          AND ERROR EXITS IN QTFI ROUTINE GNDT ALL CAUSED 
          BY NETWAIT EXITING WITH AN OUTSTANDING NETWAIT
          WITHOUT RECALL.  FIX SEVERAL PROBLEMS WITH
          CHARACTER CONVERSION. 
          NAD/EEN  03/10/82  MANY FIP MODULES 
  
 F5471DN  UPDATE DMPNAD SO THAT IT WILL BE COMPATIBLE 
          WITH CVL INTERFACE CHANGES FOR NOS. 
          GSA    03/21/82          DMPNAD 
  
 F5471PN  UPDATE RHF PP ROUTINES TO HANDLE BIT CHANGES
          IN THE NAD EST ENTRY FOR NOS. 
          GSA    03/21/82          COMNOSDEF,NDR,NLD,RHH
  
          F5471PNA                 COMNOSDEF
          F5471PNB                 NDR
          F5471PNC                 NLD
          F5471PND                 RHH
  
 RHFA025  THIS MOD ADDS CODE TO RHF TO TIME OUT A CONNECTION REQUEST
          MADE TO A REMOTE MAINFRAME AND RETURN A CON/ACRQ/A TO THE 
          INITIATOR.
          MTE    03/18/82          COMRQUE, CONARQR, TIMEVNT, AGEREQ
  
 RHFA189  THIS PSR CHANGES CODE IN NLD TO USE THE EAT 
          TO CHECK IF CALLING CP PROGRAM HAS RESERVED THE 
          CORRESPONDING EST ENTRY.
          GSA    02/15/82          COMNOSDEF,NLD
  
          RHFA189A                 COMNOSDEF
          RHFA189B                 NLD
  
 RHFA211  APPLICATIONS SOMETIMES ABORT WITH ERROR CODE 1 RETURNED 
          BY NETON.  THE BIT DEFINITIONS IN THE FIP SSC BLOCK WERE
          REVERSED CAUSING NETON TO FAIL IF RHF HAD AN OUTSTANDING
          SSC CALL AT THE TIME OF THE NETON REQUEST.
          EEN/NAD 04/05/82   COMACBF,NETON
  
 RHFA228  THIS MOD ALLOWS AN APPLICATION THAT HAS ESTABLISHED AN EOJ
          CONNECT TO COME BACK INTO RHF EVEN THOUGH THE APPLICATION 
          HAS SINCE BEEN DISABLED OR IDLEDOWN IS NOW IN PROGRESS. 
          MTE    03/10/82          FINDAPL
  
 RHFA234  THIS MOD ADDS CODE TO RHF TO ISSUE A DAYFILE MESSAGE AND
          ABORT WHEN IT CANNOT ATTACH RCFILE. 
          MTE    03/18/82         GETFILE 
  
 RHFA317  THIS MOD ADDS CODE TO RHF TO VALIDATE THE ACN ON AN 
          INCOMING SUPERVISORY MESSAGE. 
          MTE    03/10/82          SUPRMSG
  
 RHFA359  THIS PSR ADDS CODE TO NDR OVERLAY 2NW 
          (WRITE PATH DATA) TO MAKE SURE THE CORRECT
          BYTE MULTIPLE IS OUTPUTED FOR EACH CHARACTER
          TYPE. 
          GSA    03/24/82          NDR
  
 C5471QL  CORRECTIONS TO NOS QTF FEATURE CODE (PL1L COMCDEF). 
          RLF/MMC 04/17/82         COMCDEF
  
 F5471DF  ADD DIRECTIVES FILE PROCESSING SUBROUTINES TO LCNLIB FOR
          USE BY MFLINK AND MFQUEUE DIRECTIVE PROCESSING. 
          JPK    04/09/82    COMDFRD,DFINIT,DFREAD,DFTERM,DF$RTB,DF$CMP 
  
 F5471FL  NOS FEATURE CODE FOR MFLINK/PTFS PL1L COMMON DECKS. 
          NAD    04/27/82    COMCPTF,ABT,GMB,PJN,SNP
  
 RHFA368  THIS PSR ADDS CODE TO NDR TO SET BOTH THE 
          EOR AND PRU BITS ON BLOCKS BEING SENT 
          THAT HAVE THE LOCAL ACK BIT SET.
          GSA    04/26/82          NDR
  
 RHFA375  THIS PSR ADDS CODE TO THE USER CONTROL POINT SWAP 
          ROUTINE IN NDR TO PREVENT NDR FROM ATTEMPTING TO
          SWAP TO RHFS CONTROL POINT IN NOS.
          GSA    04/27/82          NDR
  
 RHFA387  NOS BML MESSAGES REQUIRE BYTE COUNT IN DFM CALL.
          GSA    4/17/82     COMNADCER (NDR,NLD,5CV)
  
 RHFA399  RHF WAS GOING IDLE WITH A QUEUE ENTRY LEFT ON THE WAITSWAP
          QUEUE.  THIS COULD CAUSE RHF MODE ERRORS OR RHF LOOPING.
          ALSO CORRECT PROCESSING OF WAITSWAP ENTRIES IN SSFCALL. 
          TGP    04/15/82    ACTIVE,SSFCALL 
  
 C5471FC  CORRECT PROBLEMS IN NETXFR: 
          - IF SHORT OUTPUT PRU WRAPPED AROUND BUFFER, BAD CONTROLWORD
            LENGTH WAS GENERATED.  DEFINE NEW FIELD, OTEXTBYT, TO KEEP
            TRACK OF OUTPUT LENGTH. 
          - ENSURE OTWRAP FLAG IS CLEARED UPON OUTPUT PRU TERMINATION.
          - CORRECT INREQ TO IGNORE EOR BIT IF CONTROLWORDS.
          - CWBYTC WAS NOT SET PROPERLY FOR WORD CASE IN SHRTOUT. 
          NAD    05/09/82    COMAFET,EXTENTS,FULLOUT,NEWOUT,SHRTOUT 
  
 RHFA316  FIP TIME-OUT CORRECTED TO ADJUST FOR SYSTEM CLOCK OVERFLOW. 
            RHFA316  - COMACBX (INITIME)
            RHFA316A - CHKTIME
          DPK    05/07/82          COMACBX,CHKTIME,INITIME
  
 C5471FL  MORE CORRECTIONS TO PL1L MFLINK/PTFS COMMON ROUTINES. 
          NAD    05/07/82    COMCPTF,SNP,SRM,STT,WLB,ABT(PURGED)
  
 RHFA455  RHF CAN HANG OR MODE OUT IF ITS COUNT OF ACTIVE APPLICATIONS
          GOES NEGATIVE.  THIS CAN OCCUR IF TWO NETOFFS ARE RECEIVED
          FROM AN APPLICATION AT ABOUT THE SAME TIME.  THIS CODE
          CORRECTS THE PROBLEM. 
          TGP    05/16/82    MOPUPQS  (RHF) 
  
 RHFA450  FIP (XFRCOMP) USES PERIODIC RECALL WHILE WAITING FOR REMOTE-
          FET COMPLETION. (AUTO-RECALL CAUSES OCCASIONAL ABORTS.) 
          DPK    05/14/82          XFRCOMP
  
 RHFA428  PREVENT MLTF ABORTS DUE TO MORE THAN ONE SEQUENCER JOB RUNNING. 
          NAD    05/07/82    MLTFPROC 
  
 RHFA422  VARIOUS PROBLEMS CAN OCCUR IF AN OPERATOR ENABLES AN AUTO-
          START APPLICATION (CAUSING THAT APPLICATION TO BE STARTED)
          WHEN THE APPLICATION IS ALREADY NETTED ON TO RHF.  THIS CODE
          BLOCKS THE APPLICATION STARTUP IF THE APPLICATION IS ALREADY
          NETTED ON.
          TGP    05/16/82    APPLDISEN (RHF)
  
 RHFA406  THIS PSR ADDS CODE TO NDR OVERLAYS 2NX
          (FET READC) AND 2NY (FET WRITEC) TO PROPERLY
          HANDLE THE CASE WHERE A FULL PRU (64 WORDS) HAS A 
          NON-ZERO UNUSED BIT COUNT.
          THIS PSR ALSO MAKES SURE THAT INCOMING AND
          OUTGOING ASCII 8/12 DATA ALWAYS HAS A UBC THAT
          IS A MULTIPLE OF 12.
          GSA    05/04/82          NDR,COM2NQ,COM2NS
  
          RHFA406A                 NDR
          RHFA406B                 COM2NQ 
          RHFA406C                 COM2NS 
  
 RHFA398  CORRECT DEFAULT SPECIFICATIONS IN RCFGEN. INITIALIZE MIN AND
          MAX ACN VALUES IN THE APPLICATION HEADER..  LACK OF 
          INITIALIZATION OF THESE PARAMETERS CAN CAUSE RHF MODE ERRORS. 
          TGP    04/15/82    RCFGEN 
  
 RHFA451  FIP COMPUTES FET BUFFER SPACE CORRECTLY.
            RHFA451  DATAWDS
            RHFA451A FREEWDS
          NAD    05/14/82          DATAWDS,FREEWDS
  
 RHFA037  NOS SPUN-OFF JOBS DO NOT PRODUCE ANY OUTPUT IF ERRORS OCCUR 
          SINCE RHF ROUTES JOB WITH DC=NO.  CHANGE SKELETON CONTROL 
          STATEMENT SEQUENCE IN RCFGEN TO ISSUE *SETJOB(DC=DF)*  AFTER
          EXIT PROCESSING TO ENSURE FILE OUTPUT AND DAYFILE ARE 
          PRINTED.
          NAD    05/25/82    RCFGEN 
  
 RHFA064  THIS PSR REMOVES CODE FROM NDR THAT IS NO 
          LONGER NECESSARY SINCE THE REWRITE OF THE 
          LOAD OVERLAY ROUTINE. 
          GSA    05/18/82          NDR,COMFETIO 
  
          RHFA064A                 NDR
          RHFA064B                 COMFETIO 
  
 RHFA337  THIS PSR INSERTS TWO DECKS INTO LCNLIB FOR
          USE BY MLTF IN CREATING MEANINGFUL ERROR MESSAGES.
          THIS PSR ALONG WITH PSR RHFA354 ALLOW MLTF TO 
          ISSUE APPROPRIATE DIAGNOSTICS.
          GSA    05/14/82          BINTOHD,BINTOOD,RHFOVL 
  
 RHFA354  THIS PSR ALONG WITH PSR RHFA337 MAKE CHANGES TO MLTF
          AND LCNLIB TO ALLOW MLTF TO ISSUE APPROPRIATE 
          DAYFILE MESSAGES. 
          GSA    05/14/82          COMNCOM,NETLOG,SENDMES,GET$LOG 
  
 RHFA458  CORRECT SPACE CALCULATION IN OUTREQ TO PREVENT HANG.
          CORRECT NOS COMPILATION ERRORS IN FULLOUT AND VALLOCF.
            RHFA458   FULLOUT 
            RHFA458A  OUTREQ
            RHFA458B  VALLOCF 
          DPK    05/27/82          FULLOUT,OUTREQ,VALLOCF 
  
 RHFA469  MODIFY WMB TO SET CONNECTION BROKEN STATUS IF APPLICATION 
          TIMEOUT OCCURS.  ALSO IMPROVE APPLICATION PERFORMANCE 
          BY EXECUTING SERIES OF SHORT NO-ROLLOUT NETWAITS
          BEFORE LONG NETWAIT.  THIS TENDS TO HELP MFLINK AND PTFS
          STAY IN SYNCH BY NOT ROLLING OUT PREMATURELY. 
          NAD    05/22/82    WMB (MFLINK,PTFS,FTFS) 
  
 F5471EP  THIS PSR CHANGES THE SUBSYSTEM PP AND CP
          ROUTINES TO USE THE SSJ= ENTRY POINT RATHER THAN
          USING SYSTEM ORIGIN.
          GSA    02/28/82          COMNOSDEF,RHH,NLD,RHF,DMPNAD 
                                   QTFS,PTFS
  
          F5471EPA                 COMNOSDEF
          F5471EPB                 RHH
          F5471EPC                 NLD
          F5471EPD                 RHF
          F5471EPE                 DMPNAD 
          F5471EPH                 HISTORY (PL91/REL15B)
          F5471EPF                 QTFS 
          F5471EPG                 PTFS 
  
 RHFA197  THIS PSR CHANGES RHF TO SPIN OFF BATCH ORIGIN 
          JOBS INSTEAD OF SYSTEM ORIGIN JOBS IF POSSIBLE. 
          CURRENTLY ALL JOBS ARE SYSTEM ORIGIN. 
          TGP    06/10/82          AUTLOAD,BATCJOB,STRTJOB  (RHF) 
                                   UCPVAL 
  
 RHFA384  THIS PSR ADDS CODE TO RHF TO ALLOW RHF TO ATTACH
          THE CONFIGURATION FILE UNIQUE TO EACH MAINFRAME BY
          USING THE MAINFRAME#S PID.
          GSA    06/04/82          STARTUP,GETFILE
  
          RHFA384A                 STARTUP
          RHFA384B                 GETFILE
  
 RHFA491  CORRECT RHH TO HANDLE THE TAPE COUNT FIELDS 
          PROPERLY. 
          JWG    06/08/82          RHH
  
 RHFA454  THIS PSR UPDATES FTF, FTFS, AND PTFS SO THAT THEY 
          SEND THE CORRECT FILE SIZE IN THE LEVEL 7 PROTOCOL
          MESSAGES. 
          GSA    05/27/82          GFL,FTF,FTFS,PTFS
  
          RHFA454A                 GFL
          RHFA454B                 HISTORY (PL91/REL15B)
          RHFA454C                 FTF
          RHFA454D                 FTFS 
          RHFA454E                 PTFS 
  
 RHFA020  THIS PSR ENHANCES THE CURRENT RHF REPRIEVE
          PROCESSING CODE.
          GSA    06/12/82          DUMPFL (RHF) 
  
 RHFA035  THIS MOD ADDS CODE TO RHF TO CALL MAI TO SWAP IN MFINT WHEN 
          THERE IS NETWORK ACTIVITY FOR ITF.
          MTE    05/24/82          TIMEVNT, MUJACT, CKSWPIN 
  
 RHFA376  THIS PSR ADDS CODE TO RHF TO CLEAR OUTSTANDING
          NETWAIT REQUESTS WHEN AN EOJ CONNECT IS RECEIVED. 
          THIS PSR FIXES CODE IN RHF TO PROPERLY MAKE THE 
          EOJ CONNECT REQUEST.
          GSA    06/09/82          CTRLNFO,SETLTC (RHF) 
  
 RHFA029  FIP MODIFICATIONS FOR TAPE I/O.  INPUT TAPE MAY BE BINARY OR
          BINARY OR CODED, BUT NOT BOTH.  OUTPUT TAPE WILL BE BINARY. 
            RHFA029   COMACBX (PRSTFIP) 
            RHFA029A  COMADEF 
            RHFA029B  COMAFET 
            RHFA029C  INREQ 
            RHFA029D  MOREIN
            RHFA029E  MOREOUT 
            RHFA029F  NEWIN 
            RHFA029G  NEWOUT
            RHFA029H  OUTREQ
            RHFA029I  SHRTOUT 
            RHFA029J  VALLOCF 
          DPK    06/29/82         COMACBX,COMADEF,COMAFET,INREQ,MOREIN, 
                                   MOREOUT,NEWIN,NEWOUT,OUTREQ, 
                                   SHRTOUT,VALLOCF
  
 RHFA285  FIP ERROR PROCESSING REVISED TO RECOGNIZE QUIT COMMAND(32), 
          DATA-TRANSFER-PHASE ATTRIBUTE (23) = SENDER ERROR (0029), 
          AND TO SET CIO ERROR CODE IN DAYFILE MESSAGE. 
          NOTE - DECK DSIPLEV IS DELETED. 
  
            IDENTIFIER   DECK 
  
            RHFA285      COMACBX (PRACKM,PRNAKM)
            RHFA285A     CIOERRC
            RHFA285B     DODPR
            RHFA285C     ENDXFR 
            RHFA285D     OUTREQ 
            RHFA285E     PENDACK
            RHFA285F     PENDXFR
            RHFA285G     PLEV7M 
            RHFA285H     PRACKM 
            RHFA285I     PRQUIT 
            RHFA285J     RHFERRC
            RHFA285K     XFRCOMP
            RHFA285L     XFRINIT
  
          DPK    06/27/82          COMACBX,CIOERRC,DODPR,ENDXFR,
                                   OUTREQ,PENDACK,PENDXFR,PLEV7M,PRACKM,
                                   PRQUIT,RHFERRC,XFRCOMP,XFRINIT 
  
 RHFA494  THE LNDR CONFIGURATION STATEMENT, IF ANY, MUST
          PRECEDE THE FIRST APPL STATEMENT IN ANY RCFGEN RUN. 
          THIS MOD ADDS CODE TO ENFORCE THIS REQUIREMENT DURING 
          THE RCFGEN RUN. 
          TGP    6/10/82           RCFGEN 
  
 RHFA036  RHF SHOULD REFRESH APPL DISPLAY.  CODE ADDED TO UPDATE
          THE ACTIVE APPLICATION DISPLAY WHENEVER A NETON OR NETOFF 
          OCCURS. 
                 IDENT   RHFA036    - COMRAPL 
                         RHFA036A   - INITAPL 
                         RHFA036B   - NETOFF$ 
                         RHFA036C   - CHCMD 
 RHFA149  PATH COMMAND ACCEPTS NON-HEXADECIMAL VALUES FOR AC, DD, 
          AND ND PARAMETERS.  CODE ADDED TO PROPERLY DETECT AN
          ERROR IF NON-HEX VALUES ARE ENTERED.
          KEK    06/28/82          HDTOBIN
  
 RHFA163  ENABLE/DISABLE COMMANDS DO NOT WORK WITHOUT TERMINATING 
          PERIODS.  CODE ADDED TO MAKE THE PERIOD OPTIONAL. 
          KEK    06/28/82          GETPAR 
  
 RHFA411  THIS PSR ADDS CODE TO LCNLIB ROUTINE DFINIT TO ALLOW
          NOS TO USE A DIRECTIVE FILE LFN THAT HAS A DIGIT FOR
          THE FIRST CHARACTER.
          GSA    06/24/82          DFINIT 
  
 RHFA415  THIS PSR ADDS CODE TO LCNLIB ROUTINE DFINIT TO MAKE 
          SURE THAT ALL CHARACTERS IN THE DIRECTIVE FILE LFN
          ARE VALIDATED BEFORE IT ATTEMPTS TO USE THE FILE. 
          GSA    06/24/82          DFINIT 
  
 RHFA416  THIS PSR ADDS CODE TO LCNLIB ROUTINE DFINIT TO
          DISCONTINUE PROCESSING WHEN THE INPUT DIRECTIVE FILE
          LFN IS NOT VALID. 
          GSA    06/24/82          DFINIT 
  
 RHFA473  ENABLE,0 IN ID DISPLAY ABORTS RHF.  CODE
          ADDED TO ISSUE INVALID COMMAND. 
          KEK    06/28/82          IDDISEN
  
 RHFA474  PAGING FORWARD AT END OF APPL DISPLAY ABORTS RHF.  CODE 
          ADDED TO DISPLAY THE LAST APPLICATION WHEN PAGING FORWARD AT
          THE END OF APPL DISPLAY.
          KEK    APPLDSPL          07/09/82 
  
 RHFA489  FIP MODIFIED TO PREVENT OCCASIONAL PROTOCOL ERRORS WHILE
          PROCESSING MULTIPLE FILE TRANSFERS.  PROCEDURE *PUTLEV7*
          ADDED TO ENSURE THAT FIP SENDS ONE NETWORK COMMAND BEFORE 
          SENDING ANOTHER.
  
            RHFA489   COMACBX (PRNAKM,PUTLEV7)
            RHFA489A  CALLNP
            RHFA489B  CIOERRC 
            RHFA489C  ENDXFR
            RHFA489D  NPLSTM
            RHFA489E  PENDXFR 
            RHFA489F  PRNAKM
            RHFA489G  PROTERR 
            RHFA489H  VALLOCF 
  
          DPK    07/01/82          COMACBX,CALLNP,CIOERRC,ENDXFR, 
                                   NPLSTM,PENDXFR,PRNAKM,PROTERR,VALLOCF
  
 C5471QW  MORE QTF/QTFS CORRECTIONS AND ENHANCEMENTS: 
          - CORRECT JOB NAME AND BANNER PAGE NAME PROCESSING; 
          - AS AN INTERIM SOLUTION, HAVE QTF EVICT ANY FILE 
            REJECTED BY A SERVICER DUE TO A "USER ERROR"
            (I.E. INVALID USER NAME OR PASSWORD, INVALID EXPLICIT 
             TEXT, INVALID OUTPUT DEVICE);
          - MODIFY QTFS TO DETECT INVALID USER NAME ERRORS FROM 
            DSP AND REFLECT SUCH IN STOPR STATE-OF-TRANSFER;
          - FIX UP MORE DAYFILE MESSAGES. 
  
          C5471QW  - PL91 DECKS 
          C5471QWA - PL1L COMDECKS (COMCAPR,COMCDEF)
  
          MMC/NAD  07/11/82        QTF,QTFS (MANY DECKS)
  
 RHFA271  PATH COMMAND ACCEPTS EXTRA DIGITS ON AC DD, LT, ND AND
          RT PARAMETERS.  CODE ADDED TO DETECT AN ERROR IF
          TOO MANY DIGITS ARE ENTERED.
                 IDENT  RHFA271    - PATHC
                        RHFA271A   - GETPAR 
                        RHFA271B   - COMRDSDL 
          KEK    06/28/82          PATHC,GETPAR,COMRDSDL
  
*L577*  ****************************************************************
  
 RHFA373  DMPNAD ERROR MESSAGE CHANGED -
          * DMPNAD ABORTED - BAD CHARACTER IN NUMERIC FIELD.* 
          ENSURE CHANNEL NUMBER IS OCTAL. 
  
          DPK    07/08/82          DMPNAD 
 RHFA030  ADD DBGAVAIL AND DBGXFER PARAMETERS TO NETDBG CALL. 
          NEW FORMAT IS --
              NETDBG (DBGSUP, DBGDATA, DBGAVAIL, DBGXFER) 
          WHERE 
                DBGXFER CONTROLS LOGGING OF TRANSFER MESSAGES AND 
                DBGAVAIL IS A RETURN PARAMETER INDICATING DEBUG 
                CAPABILITY AVAILABLE
  
          RHFA030      NETDBG     (PL1L)
          RHFA030A     COMACBF    (PL1L)
          RHFA030B     DAYFMSG    (PL1L)
          RHFA030C     CMACROS    (PL1L)
          RHFA030D     PL91 HISTORY ENTRY ( DUPLICATE OF PL1L)
          RHFA030E     FTF         (PL91) 
          RHFA030F     FILXFR      (PL91) 
          RHFA030G     FTFS        (PL91) 
          RHFA030H     QTFI        (PL91) 
          RHFA030I     QTFS        (PL91) 
          RHFA030J     PTFS        (PL91) 
          RHFA030K     PL92 HISTORY ENTRY ( DUPLICATE OF PL1L)
          RHFA030L     SETUP(ITF)  (PL92) 
          KEK    06/17/82          NETDBG,COMACBF,DAYFMSG,CMACROS 
                                   FTF,FILXFR,FTFS,QTFI,QTFS,PTFS 
                                   SETUP
  
 RHFA106  INVALID TALBE COMMAND PROCESSED AS VALID.  CODE ADDED TO
          ISSUE INVALID COMMAND IF NON-EXISTENT PARAMETERS ON DISPLAY 
          COMMANDS. 
          KEK    07/09/82          PCMD 
  
 RHFA476  DISABLING AN APPL NOT CONSISTENT WITH ID OR PATH.  CODE ADDED 
          TO ISSUE INVALID COMMAND IF THE ORDINAL SPECIFIED EXCEEDS THE 
          NUMBER OF APPLICATIONS. 
          KEK    07/07/82          APPLDISEN
  
 RHFA153  FIP CORRECTED TO BLANK FILL FILE NAMES INCLUDED IN DAYFILE
          MESSAGES, TO AVOID UNINTENTIONAL TRUNCATION WHEN NAME 
          IS LESS THAN 7 CHARACTERS.
          NEW COMPASS ROUTINE *REPZERO* ADDED.
            RHFA153   NETXFR
            RHFA153A  PLEV7M
            RHFA153B  PRACKM
            RHFA153C  RHFERRC 
            RHFA153D  VALLOCF 
            RHFA153E  XFRCOMP 
          DPK    07/07/82          NETXFR,PLEV7M,PRACKM,RHFERRC,VALLOCF,
                                   XFRCOMP
  
 RHFA374  DMPNAD DETECTS FILE NAMES .GT. 7 CHARACTERS.
          ERROR MESSAGE CHANGED - 
          * DMPNAD ABORTED - MORE THAN 7 CHARACTERS IN NAME.* 
          DPK    07/08/82          DMPNAD 
 RHFA083  ENABLE COMMAND DOES NOT DETECT INVALID FORMAT.  CODE ADDED TO 
          ISSUE ERROR IF MULTIPLE ORDINALS SPECIFIED ON ENABLE/DISABLE
          COMMANDS. 
          KEK    06/30/82          ORDCH
  
 RHFA483  THIS PSR ADDS CODE TO LCNLIB ROUTINE DF$ISM 
          TO MAKE SURE THE PROGRAM NAME IS SEVEN CHARACTERS 
          AND BLANK FILLED BEFORE IT IS INSERTED INTO THE 
          DAYFILE MESSAGE.
          GSA    07/06/82          DF$CMP 
  
 RHFA125  THIS PSR ADDS CODE TO LCNLIB ROUTINE WMB AND FTF
          TO NOTIFY USERS WHEN DELAY IS CAUSED BY REMOTE
          MAINFRAME. I.E. WAIT FOR PERM FILE, WAIT FOR
          PACK, OR WAIT FOR REMOTE RHF. 
          GSA    07/11/82    WMB,COMFFTF,FTF
  
          RHFA125            HISTORY  (PL1L)
          RHFA125A           WMB
          RHFA125B           HISTORY  (PL91)
          RHFA125C           COMFFTF
          RHFA125D           FTF
  
 RHFA366  ERROR MESSAGES ARE NOT INFORMATIVE TO THE USER
          AS TO WHAT DECK IS ISSUING THE MESSAGE. THE SUBROUTINE
          CDD IN PTFS DOES NOT ANALYZE AND HANDLE THE DD ARGUMENT 
          CORRECTLY. THIS IDENT FIXES THESE PROBLEMS. 
          LRW    07/09/82    FTF,PTFS,FTFS,COMFFTF (PL91) 
                             GMB,PRP,PDP,PTP,COMCPTF  (PL1L)
  
          RHFA366            FTF,PTFS,FTFS,COMFFTF
          RHFA366A           COMCPTF,GMB,PRP,PDP,PTP
  
 RHFA459  THIS PSR ADDS CODE TO LCNLIB ROUTINE GFL, FTF, AND
          FTFS TO PROPERLY DETECT ERRORS IN INCORRECT FILE
          PERMISSIONS.
          GSA    07/11/82    GFL,FTF,FTFS 
  
          RHFA459            HISTORY  (PL1L)
          RHFA459A           GFL
          RHFA459B           HISTORY  (PL91)
          RHFA459C           FTF
          RHFA459D           FILXFR 
  
 RHFA564  THIS PSR CHANGES CODE IN FIP ROUTINE XFRINIT TO 
          MAKE SURE THAT THE APPLICATION ADDRESS IS UPDATED 
          ON EACH ENTRY IN CASE BACK TO BACK MFLINKS GET
          A DIFFERENT APPLICATION TABLE ADDRESS IN RHF. 
          GSA    07/21/82          XFRINIT  (FIP) 
  
 RHFA562  THIS PSR ADDS CODE TO RHF TO USE THE SF.EXIT
          FUNCTION TO PROPERLY TERMINATE ITS SCP STATUS.
          GSA    07/16/82          CONTROL,DUMPFL  (RHF)
  
 RHFA571  THIS PSR FIXES A PROBLEM ON NOS, IN LCNLIB ROUTINE WMB, 
          WHICH IS CAUSED BY USING X1 AS THE FET ADDRESS IN 
          THE WRITEC MACRO. 
          GSA    07/28/82    WMB
  
 C5471FCA CORRECTION FOR FIP FEATURE (IDENT F5471FC) ---
          1.  ALLOW TRANSFER OF C6 AND C8 MODE FILES (NOS). 
          2.  ELIMINATE ADDITION OF EMPTY RECORDS TO END OF 
              SOME TRANSFERRED FILES. 
  
          DPK    08/19/82          MOREIN,SHRTOUT 
  
 RHFA543  PTFS ACCOUNT MESSAGE USES *KRPS* INSTEAD OF *KUNS*. 
          THIS IDENT FIXES THIS PROBLEM.
                 LRW         08/05/82            VCP,COMCPTF
  
                 RHFA532                         COMCPTF
 RHFA559  TEMPORARY FIX TO PREVENT RHF SUBSYSTEM FROM ABORTING
          QTF/QTFS WITH APPLICATION NOT NETTED ON MESSAGE.
          THE PROBLEM IS CAUSED BY THE NETOFF SF.LIST FUNCTION
          NOT BEING PROCESSED COMPLETELY WITH ONE SSF CALL. 
          THE TEMPORARY FIX IS TO HAVE RHF IGNORE OPERATING 
          SYSTEM GENERATED UCP TERMINATION REQUESTS FOR ALREADY 
          NETTED-OFF APPLICATIONS.
          TGP    08/05/82    NOAPLAD
  
 F5471QM  PL1L CODE FOR QTF/QTFS REJECTED FILE ENHANCEMENTS.
          NAD    08/12/82    COMCDEF,COMCAPR,NP$SYM 
  
 RHFA587  THIS MODSET SETS THE SERVICE CLASS OF *CT* TO ANY 
          JOB THAT IS ROUTED BY THE *RHF*.
          MMC. 08/25/82. RHF/BATCJOB. 
  
 RHFA600  THIS MODSET CHANGES CODE IN DF$CMP SO THAT *MFLINK* AND 
          *MFQUEUE* CAN ACCEPT THE INPUT FROM *ASCII* TYPE TERMINAL.
          MMC.  82/08/31.  DF$CMP/FIP.
  
 RHFA608  THIS PSR ADDS CODE TO RHF ROUTINE AUTLOAD TO
          USE THE APPROPRIATE #TY# PARAMETER WHEN SETTING 
          UP A JOB TO LOAD A NAD. 
          GSA    09/07/82          AUTLOAD
  
 RHFA630  NETXFR RETURNS CORRECT STATUS CODE (3 - CONNECTION BROKEN)
          WHEN FC/BRK/R RECEIVED (INSTEAD OF 18 - CONTROLWORD FORMAT
          ERROR). 
          DPK    09/14/82          PRASM
  
 RHF0010  THIS PSR ADDS CODE TO RHH TO VERIFY THAT THE
          DAYFILE FLUSH HAS COMPLETED BEFORE ATTEMPTING 
          TO COPY THE FST POINTERS. 
          GSA    09/08/82          RHH
  
 C5471QM  ADDITIONAL QTF/QTFS REJECTED FILE ENHANCEMENTS. 
          NAD    09/27/82          COMCAPR,COMCDEF
  
 F5471CP  CHANGE RHF SPOT JOB SKELETON IN RCFGEN TO PRODUCE A DUMP
          WHEN AN APPLICATION ABORTS.  CHANGE THE OPERATOR PAUSE MESSAGE
          TO ALLOW OPERATOR TO CONTROL WHETHER DUMP PRINTS OR NOT.
          UPDATE COPYRIGHT NOTICES. 
          NAD    09/29/82    COMCBEGN,RHFDATA,BATCJOB,RCFGEN
  
 F5471PR  THIS FEATURE IS AN ENHANCEMENT TO NDR TO IMPROVE
          PERFORMANCE OF DISK TO DISK THROUGHPUT THROUGH
          THE LCN.  THE FEATURE ADDS CODE TO DELAY IN NDR IN
          ORDER TO SYNCHRONIZE WITH THE DISKS.
          GSA    09/23/82          NDR
  
 F7436MF  THIS CODE ADDS SUPPORT FOR MULTIFILE TAPES TO FIP. THIS 
          CODE WAS ADDED FOR SUPPORT OF THE CYBER 200 LOAD AND DUMP 
          CAPABILITY. 
          TGP    09/29/82    COMADEF,VALLOCF (FIP)
  
 RHFA530  MODSET CHANGES THE RHF EVENT DESCRIPTOR FROM *7* TO 
          SYMBOL *RHFE* IN ROUTINE N$EESET. 
          MMC.   82/09/14.  N$EESET/RHF.
  
 RHFA566  MODSET CHANGES THE *MLTF* PROCEDURE FILE TO TEST IF 
          THE FILE IS ON THE MASS STORAGE BEFORE RENAME IT. 
          MMC.   82/09/21.   MLTFPROC.
  
 RHFA588  MODSET CHANGE CODE IN ROUTINE *VCP* OF LCNLIB SO THAT 
          IT WILL ACCEPT 11 BIT MASK COUNT AND ACPET THE ZERO 
          PARAMETER SPECIFIED IN THE *MIN* POSITION OF *DEFPOS* AND 
          *DEFPAR* MACROS.
          MMC.   82/09/20.   VCP/LCNLIB.
  
 RHFA596  FIP MODIFIED TO TIME OUT DURING FILE TRANSFERS. 
            IDENT    DECK 
            RHFA596  COMADEF
            RHFA596A COMACBX
            RHFA596B COMAFET
            RHFA596C NETXFRC
            RHFA596D CHKTIME
          DPK    09/29/82          COMADEF,COMACBX,COMAFET
                                   NETXFRC,CHKTIME
  
 RHFA640  THIS PSR ADDS CODE TO RHF AND RHH TO CHANGE THE 
          AUTO-LOAD PROCEDURE OF NAD#S.  NAD#S WILL NOW 
          ONLY BE AUTO-LOADED IF THEIR EST ENTRY SHOWS
          THAT THE ON BIT IS SET AND THE CONTROLWARE NOT LOADED 
          FLAG IS SET.
          GSA    09/21/82          COMRNET,AUTLOAD,IDLE,RHH 
                                   CTRLMSG,STARTUP,PATHVAL
                                   COMRQUE,REMCONR
  
          RHFA640A                 COMRNET
          RHFA640B                 COMRQUE
          RHFA640C                 STARTUP
          RHFA640D                 AUTLOAD
          RHFA640E                 IDLE 
          RHFA640F                 CTRLMSG
          RHFA640G                 PATHVAL
          RHFA640H                 REMCONR
          RHFA640I                 RHH
  
 C5471FCB FIP MODIFIED TO USE I/O BUFFERS THAT VARY IN SIZE 
          ACCORDING TO THE TRANSFER MODE (UH,US,UU,C6,C8).
          "FETBUFSIZE" IS THE INSTALLATION PARAMETER CONTROLLING
          THE SIZE OF LOCAL AND RHF FET BUFFERS.
            IDENT     DECK
            C5471FCB  COMADEF 
            C5471FCBA COMACBX 
            C5471FCBB BUILDFT 
            C5471FCBC CHKFTT
            C5471FCBD VALLOCF 
            C5471FCBE XFRINIT 
          DPK    10/06/82          COMADEF,COMACBX,BUILDFT, 
                                   CHKFTT,VALLOCF,XFRINIT 
  
 F5471LD  THIS PSR ADDS CODE TO RHF TO DISTINGUISH BETWEEN
          LIDS AND PIDS BEING DISABLED OR UNDEFINED AT
          THE LOCAL HOST. 
          GSA    10/05/82    COMRRTN,ACRQA,CONARQR
                             AGEREQ,FTF 
  
          COMRRTN            F5471LDA 
          ACRQA              F5471LDB 
          CONARQR            F5471LDC 
          AGEREQ             F5471LDD 
          HISTORY (PL91)     F5471LDE 
          FTF                F5471LDF 
  
 RHFA554  PREVENT NLD ERROR 4 WHEN ATTEMPTING LOCAL CONTROLWARE 
          LOAD (BCPROC/LOADBC) AFTER NAD POWERED-UP OR BOARD-SWAP.
          SUBROUTINE DMS WAS READING UNINITIALIZED NAD MEMORY LOCATION
          WITHOUT IGNORING ANY TRANSIENT PARITY ERROR.
          ADD FAIL-SAFE TIME OUT TO SUBROUTINE DEL SO THAT NLD WILL 
          EVENTUALLY TIME OUT WAITING FOR REMOTE NAD OPERATIONS.
          NAD    10/13/82          NLD
  
 C5471F1  THIS MODSET CORRECTS THE CODE IN COMCPTF SO THAT
          THE *RTT* AND *STT* WILL EXTRACT THE TIME ACCORDINGLY.
          MMC.   82/10/20.
  
 RHFA670  IF PATH ABORTED STATUS IS DETECTED BY RHF BEFORE REPLYING 
          TO A CON/REQ SUPERVISORY REPLY FROM AN APPLICATION, 
          RHF WILL ATTEMPT TO SEND CON/CB SUPERVISORY MESSAGE BUT 
          NEGLECT TO COMPLETE CON/REQ MESSAGE AND APPLICATION WILL
          HANG.  CORRECT MISPLACED END STATEMENT IN COMREQN TO
          SOLVE PROBLEM.
          TGP/NAD 10/18/82   CONREQN
  
 RHFA192  THIS MOD CHANGES THE DECK NAMES FROM NIP TO NDR.
          MTE    02/02/82          STRTNDR,NDRCOMP,ASGNDR,COMRNDR 
                                   COMLIST,CONTROL,IDLE,ACTIVE, 
                                   EVNTSCN,NADREQ,NDRRSTR,ACKQ, 
                                   QUEOFF,STATCMP,STATUSF,CMPSTAT 
                                   READCMP,OVRFLOW,WRITCMP,LOCACK,
                                   FCNAK,FETCMP,NXTNADR,NADFUNC,
                                   WAITACN,FCBRKR,FCRSTR,REMCONR, 
                                   TIMEVNT
  
 *L577*    ************************************************ 
 *L587*    ************************************************ 
 RHFA594  DMPNAD (NOS VERSION) FLASHES OPERATOR MESSAGE BEFORE DUMPING
          REMOTE NAD. 
          DPK    11/18/82          DMPNAD 
  
 RHFA746  THIS IDENT ADDS CODE TO NDR TO HANDLE THE ABORT 
          RESPONSE FROM THE NAD WHEN ISSUING A SEND FLUSH 
          CONTROL STATEMENT.
          GSA    02/28/83          NDR
  
 RHFA742  THIS PSR ADDS CODE TO NDR TO MAKE SURE THAT PATHS 
          ARE PURGED IF THEY CANNOT BE NORMALLY DISCONNECTED. 
          GSA    02/03/83          NDR
  
 RHFA734  RHF (NOS) PROCESSES CTRL/INFO REQUEST PROPERLY WHEN 
          QTF SWAPPED OUT AFTER SUCCESSFUL WRITE OF NDT. (RHF DOES
          NOT RETRY WRITE.) 
          DPK    01/13/83          CTRLNDT
  
 RHFA731  COMNADCER AND NDR REVISED TO SAVE DIRECT CELLS IN PP
          INSTEAD OF IN PPMES4 TO AVOID DESTRUCTION IN CASE OF
          OVERLAY LOADING ERROR.  (NLD AND 5CV UNCHANGED.)
            IDENT     DECK
            RHFA731   COMNADCER (NDR,NLD,5CV) 
            RHFA731A  NDR 
  
          DPK    01/14/83          COMNADCER,NDR
  
 RHFA698  WMB(WAIT FOR NETWORK MESSAGE) SENDS THE MESSAGE 
          "REMOTE MAINFRAME HAS RESPONDED" ONLY WHEN IT RECEIVES
          A NON-SUPERVISORY NETWORK MESSAGE, TO AVOID CONFUSING 
          THE MFLINK USER WHEN THE CONNECTION HAS TIMED OUT.
          DPK    11/24/82          WMB
  
 RHFA656  FIP CORRECTED TO ALLOW TRANSFER OF EMPTY FILE WITHOUT 
          ANY EOI DATA BLOCK FROM NOS V1 TO NOS V2. 
          DPK    01/07/83          RHFERRC
  
 RHFA558  DMPNAD PARAMETER REQUIREMENTS CHANGED --
          - CHANNEL NUMBER (CH=) REQUIRED TO DUMP LOCAL OR REMOTE NAD.
          - NEITHER TRUNK ENABLES (LT=) NOR NAD ADDR (ND=) MAY BE 
            SPECIFIED TO DUMP LOCAL NAD.
          - BOTH LT= AND ND= REQUIRED TO DUMP REMOTE NAD. 
          DMPNAD ERROR MESSAGES CHANGED --
            DMPNAD ABORTED - CHANNEL NUMBER INVALID OR MISSING. 
            DMPNAD ABORTED - NAD ADDRESS INVALID OR MISSING.
            DMPNAD ABORTED - TRUNK ENABLES INVALID OR MISSING.
          DPK    11/29/82          DMPNAD 
  
 RHFA504  THIS PSR ADDS CODE TO NDR TO FIX A HOLE IN THE
          NDR STATUS FUNCTION WHERE NDR COULD ATTEMPT A 
          CENTRAL MEMORY READ WITHOUT HAVING THE FIELD ACCESS 
          FLAG SET. 
          GSA    02/02/83          NDR
  
 RHFA714  IF NAD IS CONNECTED TO CHANNEL 6, NOS NDR SKIPS 
          INITIALIZATION OF POINTER TO CHANNEL TABLE, CAUSING 
          NDR TO NOT SHARE THE CHANNEL WITH OTHER NDRS. 
          CHANGE DUMMY CHANNEL DEFINITION TO INVALID HARDWARE 
          CHANNEL SO THAT INITIALIZATION WILL NOT BE SKIPPED. 
          GSA    12/06/82          NDR
  
 RHFA713  THIS PSR ADDS CODE TO RHF TO RESET THE FAST TIMER 
          IN RHF AFTER COMING OUT OF THE IDLE ROUTINE SO
          THAT RHF DOES NOT TIMOUT THINGS SUCH AS CONNECT 
          REQUESTS WHILE THE FAST TIMER IS CATCHING UP TO 
          THE MAIN TIMER. 
          GSA    12/06/82          CONTROL
  
 RHFA700  NLD - NAD DUMP FUNCTION MODIFIED TO PREVENT UNWARRANTED 
          TIME-OUT WHILE DUMPING LARGE NAD MEMORY.
          DPK    11/11/82          NLD
  
 RHFA684  FIP PROCESSES QUIT (QR) COMMAND IF RECEIVED AFTER 
          END-OF-DATA (ES) SENT.
          NETXFR CHECKS FOR ASYNCHRONOUS NETWORK MESSAGE MORE OFTEN 
          WHEN TRANSFERRING CODED FILES.
            IDENT     DECK
            RHFA684   COMACBX (OUTREQ,PRACKM,PRNAKM,PROTERR)
            RHFA684A  NETXFR
            RHFA684B  CIOERRC 
            RHFA684C  OUTREQ
            RHFA684D  PENDXFR 
            RHFA684E  PRACKM
            RHFA684F  PRNAKM
            RHFA684G  PROTERR 
            RHFA684H  PRQUIT
            RHFA684I  PUTLEV7 
          DPK    11/02/82          COMACBX,NETXFR,CIOERRC,OUTREQ, 
                                   PENDXFR,PRACKM,PRNAKM,PROTERR, 
                                   PRQUIT,PUTLEV7 
  
 RHFA682  MODIFICATIONS TO MEET CURRENT NOS BML SPECIFICATIONS. 
          COMCHNRES - CLEANUP.
          COMNADCER - HARDWARE ERROR MESSAGE FORMAT CHANGES.
          COMNADIO  - CLEANUP.
          COMNOSDEF - ADD OVERFLOW MACRO FOR NOS (FROM NOSTEXT).
          NLD       - OVERFLOW (NOS). 
          RHH       - OVERFLOW (NOS). 
          5CV       - CLEANUP, OVERFLOW (NOS).
          LOG$BML   - MESSAGE FORMAT CHANGE.
  
          RHFA682                  COMCHNRES
          RHFA682A                 COMNADCER
          RHFA682B                 COMNADIO 
          RHFA682C                 COMNOSDEF
          RHFA682D                 NLD
          RHFA682E                 RHH
          RHFA682F                 5CV
          RHFA682G                 LOG$BML
  
          DPK    11/10/82          COMCHNRES,COMNADCER,COMNADIO,
                                   COMNOSDEF,NLD,RHH,5CV,LOG$BML
  
 F5636RH  IMPLEMENT CHANGES FOR *EST EXPANSION* IN NOS R6.2.
          DKE    10/25/82    COMNADCER, COMNOSDEF, NDR, NLD, RHH
  
 RHFA024  THIS PSR ADDS CODE TO RHF TO HANDLE LOGIC ERROR 
          PROCESSING IN THE SUBSYSTEM.
          GSA    10/25/82          COMRAPL,COMRNDR,COMRQUE,COMRRTN, 
                                   COMRSFC,COMRUNKN,NETGET$,NETGETL$, 
                                   NETXFR$,NETPUT$,UCPCOMP,MSGRPLY, 
                                   MSGREQ,NSUPR,READCMP,WRITCMP,
                                   FETCMP,SSFCALL,SUPRMSG,CONREQA,
                                   CONREQN,FCBRKR,FCRSTR,QERRLGL, 
                                   SSFERRP,ERRLGL,BUILDEM,RHFOVL, 
                                   CTRLNDT,CTRLNFO,MUJACT,SETLTC, 
                                   MOPUPQS,RTNSMSG,DISCARD,RSTRCVD
                                   NETWAIT$,NETON$
  
 RHFA756  WLB CALLS WMBS INSTEAD OF NETWAIT, TO ALLOW PTFS TO ROLL OUT
          WHILE WAITING FOR SUPERVISORY MESSAGE (FC/ACK). 
          WMB HAS NEW ALTERNATE ENTRY POINT (WMBS) TO WAIT ONLY FOR 
          SUPERVISORY MESSAGE, AND TO CALL NETWAIT WITH 10-SEC FIXED
          DELAY AFTER 10 SHORT-WAITS ATTEMPTED.  THIS CAUSES PTFS TO
          RELINQUISH THE CPU. 
          NETWAIT PASSES FIXED-DELAY PARAMETER TO RHF.
  
            IDENT    DECKS
            RHFA756  WLB,WMB
            RHFA756A NETWAIT
  
          DPK    03/16/83    WLB,WMB,NETWAIT
  
 RHFA755  COMMON DECKS MODIFIED -- (*ID RHFA755)
          CMACROS  - ADD MACRO DEFINITIONS FOR  MACREF, NETUXFR,
                     NETXFR, AND NETXFRC. 
          COMCMAC  - DELETE MACRO DEFINITION OF NETXFR. 
          FAKEMIC  - DELETE MICRO DEFINITIONS OF CNFG, EVENT, FAIL, 
                     FILE, INITH, INTR, LINE, LLNK, LLP, LOAD, LOUT,
                     MSG, NET, NPU, OVDAT, OVLD, PCB, QCB, STIS, STUS,
                     TCH, AND TRAF. 
          SHUT     - MAKE FIELD SYMBOL DEFINITION *SHUTYP* ACCESSIBLE.
          USERDEFS - DELETE *CALLS OF COMDECKS FILEDEF, LOUTDEF,
                     MSGDEF, AND TCHDEF.
          USERITMS - DELETE *CALLS OF COMDECKS FILE, LOUT, MSG, AND TCH.
  
          DECKS ADDED -- (*ID FIPTEXT, *ID WEOR2) 
          FIPTEXT  - COMPASS MACROS AND SYMBOLS FOR RHF APPLICATIONS. 
          WEOR2    - SEPARATE FIPTEXT FROM NP$ERR ON COMPILE FILE.
  
          COMMON DECKS PURGED --
          FILE, FILEDEF, LOUT, LOUTDEF, MSG, MSGDEF, TCH, TCHDEF. 
  
          *** NOTE - INSTALLATION DECK (PL1LI ON DECKS PL) MUST 
                     BE CHANGED TO ASSEMBLE FIPTEXT.
  
          DPK    03/17/83          CMACROS,COMCMAC,FAKEMIC,SHUT,
                                   USERDEFS,USERITMS,FIPTEXT,WEOR2
  
 F5472FP  NOS ITF - CHANGE NETXXX ENTRY POINTS TO RHFXXX. 
          SUPPLY NEW NETXXX DUMMY ROUTINE WHICH CALL RHFXXX.
          THIS ALLOWS FIP ENTRY POINTS TO BE CALLED WITH EITHER 
          NETXXX OR RHFXXX ENTRY POINT NAMES AND ALLOWS NAM AIP 
          ENTRY POINTS (NETXXX) TO BE CALLED ALONG WITH FIP (RHFXXX). 
          WHEN LOADING BOTH AIP AND FIP, THE AIP LIBRARY (NETIO OR
          NETIOD) MUST BE SPECIFIED BEFORE THE FIP LIBRARY IN 
          THE LOADER LIBRARY SEARCH LIST (I.E. LDSET,LIB=NETIO/LCNLIB.).
          DECKS AFFECTED -
                 RENAMED           NEW
                 =======           ===
  
                 RHFON             NETON
                 RHFOFF            NETOFF 
                 RHFWAIT           NETWAIT
                 RHFGET            NETGET 
                 RHFGETL           NETGETL
                 RHFPUT            NETPUT 
                 RHFDBG            NETDBG 
                 RHFUXFR           NETUXFR
                 RHFXFR            NETXFR 
                 RHFXFRC           NETXFRC
  
          NAD    03/17/83          FIP
  
 F5472RH  NOS ITF - MAKE RHF SUBSYSTEM CODE FOR NOS/BE ITF CONDITIONAL. 
          CHANGE REFERENCES FROM "ITF" TO APL$ITF DEF.
          NAD    03/17/83          COMRAPL,TIMEVNT,CKSWPIN
  
 RHFA744  THIS FEATURE ADDS CODE TO NDR IMPROVE THE FILE TRANSFER 
          RATE WHEN TRANSFERRING FILES IN #US# MODE.  THIS IS 
          TO IMPROVE TRANSFER RATES BETWEEN NOS V2 AND NOS/BE.
          GSA    01/21/83          COMFETIO,COM2NS,COM2NQ,NDR 
  
          RHFA744A                 COMFETIO 
          RHFA744B                 COM2NS 
          RHFA744C                 COM2NQ 
          RHFA744D                 NDR
  
*L5*  *********************************************************************** 
  
=COMDECK *L5A*
*L5*  **********************************************************************
  
 RHFA770  MLTFPROC (MLTF PROCEDURE) REVISED AND DECK REPLACED.
          1. NOS/BE - PREVENT POSSIBLE LOSS OF THE MLTF JOB WHEN
             RHF IS RESTARTED.
             ** NOTE - NB0E362 MUST BE INSTALLED ON PL1B. **
          2. NOS - END WITHOUT CALLING NETLOG IF THE JOB IS NOT 
             SYSTEM ORIGIN, TO PREVENT LOG-OUT OF TERMINAL USER.
          3. NOS/BE + NOS - CHANGE DEFAULT DELAY PERIOD TO 10 MINUTES.
          DPK    04/18/83          MLTFPROC 
  
 RHF0027  NLD RETURNS ERROR CODE 4 (NAD ACCESS ERROR) INSTEAD OF
          ABORTING BCLOAD/LOADBC, DMPNAD, OR MLTF (NETLOG)
          WITH THE MESSAGE  * WAITED TOO LONG FOR SHARED ACCESS.* 
          DPK    05/09/83          NLD
  
 RHF0040  RHF - COMMENTS ON THE RHF CONTROL STATEMENT CALL CAN PREVENT
          RHF APPLICATIONS FROM CONNECTING WITH EACH OTHER, BECAUSE 
          RA+71-72 CONTAIN ADDRESSES REFERENCED BY NDR AS 24-BIT FIELDS 
          BUT SET UP BY RHF AS 18-BIT FIELDS.  RHF NOW SETS UP THESE
          ADDRESSES PROPERLY BEFORE CALLING NDR.
          DPK    05/16/83          COMRLRA,STARTUP
  
 RHF0038A DFINIT -  NEW PARAMETER INDICATES ABSENCE OF DIRECTIVE FILE.
          DFTERM -  DOESN-T RETURN CONNECTED INPUT FILE.
  
          ASSOCIATED MODIFICATIONS -- 
  
          MFLINK -  DFINIT CALL MODIFIED. 
          MFQUEUE - ACCEPTS DC= PARAMETER OR ROUTING TEXT.
                    DFINIT CALL MODIFIED. 
  
                 IDENT     PL      DECKS
                 RHF0038   PL91    MFLINK,MFQUEUE 
                 RHF0038A  PL1L    COMDFRD,DFINIT,DFTERM
  
                 DPK    04/29/83          COMDFRD,DFINIT,DFTERM 
  
 RHFA772  REMOVE ALTERNATE UN=SYSTEMX FROM RHF ATTACH OF RCFMXX.
          SUBSYSTEM INITIATION ASSURES UI=377777B.  THE REDUNDANT 
          UN=SYSTEMX CAN CAUSE VALIDATION CONFLICTS SUCH THAT THE FILE
          CANNOT BE ATTACHED. 
          NAD    06/04/83          GETFILE
  
 RHFA779  NLD FUNCTION 4 CHANGED FOR NOS V2 -- THE NAD EST ENTRY IS 
          TURNED ON ONLY IF THE UP/DOWN FLAG IS CLEAR(UP) TO AVOID
          THE AMBIGUITY OF EST ON AND DOWN. 
          DPK    06/02/83          NLD
  
 C5472RH  THIS CODE IS ADDED TO RHF TO PROPERLY SWAPIN ITF ON 
          NOS IF THERE IS INPUT AVAILABLE AND ITF IS SWAPPED OUT. 
          NOS CPUMTR DOES NOT ALLOW SF.WRITE IF THE WAIT RESPONSE 
          COUNT IS ZERO.
          GSA    05/27/83         MUJACT
  
 RHFA689  RHF (NOSV2) FLASHES B-DISPLAY MESSAGE, AND RESPONDS TO
          OPERATOR *GO* ENTRY.
          DPK    06/28/83          COMRLRA,CKOPMSG,NADOFF,
                                   REQCON,RHFMSG
  
 RHFA743  RHF DISPLAYS 3-DIGIT EST ORDINAL. 
          DPK    06/15/83          COMRFLSH,NADOFF
  
 RHFA790A MFLINK - CHECK STATE-OF-TRANSFER PARAMETER VALUES AGAINST 
          SPECIFICALLY DEFINED VALUES FOR *NORMAL* AND *RETRY*, 
          AND ASSUME ALL OTHER VALUES INDICATE *ABORT*. 
  
          IDENT    PL      DECK 
          -------- ------- -------
          RHFA790  PL91    MFLINK 
          RHFA790A PL1L    COMCPTF
  
          DPK    07/12/83          COMCPTF,MFLINK 
  
*L596*  *********************************************************************** 
  
=COMDECK *L596A*
*L596*  **********************************************************************
  
 RHFA818  NDR CLEARS UNUSED BITS WITHIN PARTIALLY-UNUSED 12-BIT BYTE, 
          TO PRESERVE BINARY FILES RECEIVED FROM CYBER 200, IBM, ETAL.
          DPK    09/07/83          COM2NQ,NDR 
  
 RHFA820  MFLINK SENDS A VALID USER TEXT (ATTRIBUTE 05) WHEN A
          79-CHARACTER DIRECTIVE FOLLOWS MFLINK CALL. 
          MFLINK AND MFQUEUE FOR NOS V2 NOW RECOGNIZE DIRECTIVES
          THAT BEGIN WITH * BUT DO NOT HAVE TERMINATORS.
  
          *** NOTE - THIS MOD SET IS REQUIRED BY RHFA820A FOR PL91. 
  
          IDENTIFIER  PL    DECK
          ----------  ----  ------- 
          RHFA820     PL1L  COMDFRD,DFINIT,DF$DMP 
          RHFA820A    PL91  MFLINK,MFQUEUE
  
          DPK    09/30/83          DF$CMP 
  
*L604*  *********************************************************************** 
  
 F5R09RF  THIS FEATURE CODE IS PART OF THE FTFS REWRITE FEATURE 
          (F5R09FS).  THIS CODE IS ADDED TO RHF TO DECREASE THE 
          RECALL DELAY PERIODS IN ORDER TO DECREASE APPLICATION 
          START UP TIME.
          GSA    10/06/83          COMRNET,ACTIVE,WAIT,IDLE,WAITACN 
  
 RHFA829  NLD DELAY INCREASED TO PREVENT *NLD ERROR 4* WHEN 
          LOADING REMOTE NAD AT 4X PP SPEED.
          DPK    11/29/83          NLD
  
 F5R09HH  THIS CODE IS AN ADDITION TO THE FTFS FEATURE REWRITE
          (F5R09FS).  THIS CODE ADDS AN ADDITIONAL FEATURE TO 
          THE RHH SET FORCE EXIT PROCESSING FUNCTION (FUNCTION 7).
          THIS FEATURE IS TO SET THE MAXIMUM PRU LIMIT IN THE 
          JOB#S CONTROL POINT AREA TO ZERO TO PREVENT FTFS FROM 
          ABORTING DURING A FILE TRANSFER.  ALSO THIS CODE FIXES
          A BUG IN RHH FLUSH DAYFILE FUNCTION (FUNCTION 5).  RHH
          SHOULD WAIT UNTIL A DAYFILE FLUSH IS COMPLETE BEFORE
          RETURNING CONTROL TO THE CALLING PROGRAM. 
          GSA    09/30/83          RHH
  
 RHFA852  RHF AND RHF APPLICATIONS ARE MODIFIED TO PROPERLY HANDLE
          FC/NAK SUPERVISORY MESSAGES.  THESE FIXES (ALONG WITH 
          LOADBC/BCLOAD CHANGES TO NAD INITIALIZATION PARAMETERS) ARE 
          REQUIRED FOR SUPPORT OF 380-170 MG101-A06 CONTROLWARE.
          DPK/GSA            12/20/83 
  
                 PL1L/REL16A          PL91/REL16B 
                 ===========          =========== 
                 RHFA852 - COMADEF    RHFA852A - CMDPUT,SREQ (QTF/QTFS) 
                         - PRNAKM(FIP)
                         - GMB,SML,SRM,WLB,WMB(MFLINK/PTFS/FTFS)
  
 F7958RC  THIS FEATURE ADDS THE CAPABILITIES TO THE RHF SUBSYSTEM 
          TO UTILIZE CODE CONVERSION IN THE NAD.  THE CODE UNDER
          THIS IDENT IS ADDED TO THE RHF CONFIGURATION FILE 
          GENERATOR, RCFGEN.
          GSA    12/05/83          RCFGEN 
  
 F7958RF  THIS FEATURE ADDS THE CAPABILITIES TO THE RHF SUBSYSTEM 
          TO UTILIZE CODE CONVERSION IN THE NAD.  THE CODE UNDER
          THIS IDENT IS ADDED TO ROUTINES THAT COMPRISE THE RHF 
          SUBSYTEM CONTROL POINT. 
          GSA    09/20/83            COMRAPL,COMRNET,COMRNDR, 
                                     COMRQUE,COMRSTAT,COMRNAM,
                                     COMRRTN,COMRFLSH,CONTROL,
                                     DUMPFL,NETGET$,NETGETL$, 
                                     NETPUT$,NETXFR$,ASGNDR,
                                     VFETFNC,NDRCOMP,CMPSTAT, 
                                     FREEACN,SUPRMSG,CKESTAT, 
                                     CLEANUP,SCMCMP,ECMCMP, 
                                     CMSELR,QCMSELA,CMEXITR,
                                     RHFOVL,IDLE,SCANPTH, 
                                     REQSTAT,PATHVAL,NETWAIT$ 
                                     AGEWAIT,TIMEVNT
  
 F7958FP  THIS FEATURE ADDS THE CAPABILITIES TO THE RHF SUBSYSTEM 
          TO UTILIZE CODE CONVERSION IN THE NAD.  CODE UNDER
          THIS IDENT (F7958FP) IS ADDED TO THE RHF FILE 
          INTERFACE PROGRAM (FIP).
          GSA    10/15/83            COMADEF,COMACBX,COMADFM, 
                                     RHFUXFR,RHFXFR,RHFXFRC,
                                     BUILDFT,CHKTIME,DAMSGIN, 
                                     DAYFMSG,DFTTIND,DODPR, 
                                     ENDXFR,INTAMSG,OUTREQ, 
                                     PENDXFR,PLEV7M,PRACKM, 
                                     PRASM,PROTERR,PRQUIT,
                                     RHFERRC,VALLOCF,XFRINIT, 
                                     PSCMREP,SELCM,EXITCM,
                                     BLDTRT,RBLDFET 
  
 F7958ND  THIS FEATURE ADDS THE CAPABILITIES TO THE RHF SUBSYSTEM 
          TO UTILIZE CODE CONVERSION IN THE NAD.  THE CODE UNDER
          THIS IDENT IS ADDED TO THE RHF PP ROUTINES. 
          GSA    08/23/83          NDR,COMSEL,COMNADIO,COM2NQ 
                                   COM2NS,COMFETIO,NLD
  
 C7958ND  THIS FEATURE CORRECTION MODIFIES 5CV TO ALLOW ACCESS TO 
          REMOTE NADS FOR REMOTE LOADS AND DUMPS.  THE PROBLEM
          IS THAT 5CV DOES NOT USE THE PROPER DI INPUT SELECT FOR THE 
          PATH STATUS LENGTH (PSLN) GIVEN IN COMNADIO.  THIS CAUSED 
          LOCAL NAD DI STATUS ERRORS WHICH PREVENTED THE NAD
          ASSIGNMENT BY CVL.
          NAD    01/15/84          5CV
  
*L617*  *********************************************************************** 
  
 F5470B   NP/QTF,PTF FEATURE CODE FOR RHF PL. 
          KEK/MMC/CRL/GSA/NAD      08/30/84 
  
 C5470A   RHF GETS SFM MONITOR CALL ERROR WHEN THE LENGTH OF THE RHF
          CONFIGURATION FILE EXCEEDS 1000B.  CODE ADDED TO REQUEST
          MEMORY FOR BOTH THE RHF CONFIGURATION FILE AND THE LID TABLE. 
          KEK    09/13/84    STARTUP
  
 RHFA730  THIS PSR REMOVES SOME UNNECESSARY CODE FROM ROUTINE 
          NETOFFR IN RHF. 
          GSA    01/10/84            NETOFFR  (RHF) 
  
 RHFA290  THIS PSR ADDS CODE TO RHF ROUTINE AGENTON TO PREVENT RHF
          FROM CONTINUOUSLY SPINNING OFF SERVER JOBS THAT DO NOT
          NETON.
          GSA   01/10/84             AGENTON   (RHF)
  
 RHFA701  THIS PSR CORRECTS A PROBLEM IN RHF ROUTINE PCMD WHICH 
          CAUSES RHF DISPLAYS TO BE BLANKED.
          GSA   01/10/84             PCMD   (RHF) 
  
 RHFA015  THIS PSR ADDS CODE TO RHF ROUTINES TO PROPERLY RE-ISSUE 
          AND TIME OUT IF UNABLE TO SEND A CONTROL MESSAGE. 
          GSA    01/10/84            COMRQUE,NDRCOMP,FCRSTR,
                                     ACKQ,FCBRKR,SENDCMP, 
                                     RHFOVL,MOPQACN,WAITACN  (RHF)
  
 RHFA023  THIS CODE RELEASES UNUSED RHF FIELD LENGTH. 
          GSA    01/16/84          COMRMEM, CONTROL, RHFOVL,
                                   ACTIVE, GETFREE, FREEMEM  (RHF)
  
 RHFA724  THIS PSR ADDS CODE TO RHF TO ABORT FTFS IF A CONNECTION 
          IS BROKEN AND FTFS HAS THE END OF JOB CONNECT SET.  THIS
          PREVENTS FTFS FROM HANGING INDEFINITELY WHILE SWAPPED 
          OUT WAITING FOR A RESOURCE. 
          GSA   01/16/84             BRAKACN     (RHF)
  
 RHFA028  THIS PSR ADDS CODE TO RHF ROUTINES TO PROPERLY
          IDENTIFY AND PRINT OUT CONTROL MESSAGES THAT ARE
          REJECTED BY THE NAD, SENT TO AN UNKNOWN CONNECTION
          OR NOT RECOGNIZED AS SUPPORTED CONTROL MESSAGES.
          GSA    03/19/84            STATCMP, CTRLMSG, RHFOVL,
                                     PRCTRLM    (RHF) 
  
 RHFA828  RHF ACCEPTS SCP STATUS JOB-ALREADY-SWAPPED AS NORMAL, INSTEAD 
          OF ABORTING USER JOB WITH *FATAL SSF ERROR. FC=24,RC=44*. 
          DPK    10/24/83          NETWAIT$ 
  
 RHF0055  RHF USES CORRECT APPLICATION CONNECTION NUMBER WHEN A PATH
          ERROR OCCURS, TO PREVENT ABORT (CPU ERROR EXIT, CM OUT OF 
          RANGE). 
          DPK    10/19/83          QUEOFF 
  
 RHF0063  THIS PSR ADDS CODE TO NDR TO PROPERLY PLUG THE NAME 
          FIELD IN THE CONTROL MESSAGE HEADER.  THIS PREVENTS 
          THE SENDING OF ACK MESSAGES TO THE WRONG PATHS AND
          LEAVING APPLICATIONS HUNG WAITING FOR ACKNOWLEDGE 
          MESSAGES. 
          GSA    03/28/84          NDR
  
 RHF0105  FIP ROUTINE *CVT* RESETS THE CHARACTER COUNT DURING END-OF- 
          LINE PROCESSING, TO AVOID DESTROYING THE NEXT DATA WORD.
          (THIS PROBLEM HAS CAUSED PTFS TO HANG WHEN CONVERTING A PRINT 
          FILE TO DISPLAY CODE (DD=C6).)
          GSA    02/18/84          CVT  (FIP) 
  
 RHF0137  PROBLEM - NOS/BE FTFS JOBS WITH TAPES ASSIGNED SOMETIMESS 
          ABORTED WITH *RHF, INVALID FET PARAM.* MESSAGE. 
          SOLUTION - CORRECT NDR ROUTINE *UCP* TO INCLUDE TEST FOR
          CONTROL POINT ROLLED OUT AS WELL AS SWAPPED.
          GM/NAD 05/29/84    NDR
  
 RHF0144  PROBLEM - WHEN ACCEPTING INCOMING CONNECT REQUESTS, RHF 
          ATTEMPTS TO MOVE ALL ENTRIES ON THE CONNECTION REQUEST
          QUEUE TO THE WAITING-ASSIGNMENT QUEUE.  TWO PROBLEMS CAN
          OCCUR:  
          1. IN *REMCONR*, WHEN OBTAINING AN INCOMING CONNECT FROM
             A NAD, RHF VALIDATES THE REQUEST BUT DOES NOT TAKE INTO
             ACCOUNT PREVIOUSLY PROCESSED CONNECTS WHICH ARE STILL
             ON THE WAITING-ASSIGNMENT QUEUE.  *REMCCONR* MAY ACCEPT
             THE REQUEST, BUT DURING ASSIGNMENT, IT MAY BE DISCOVERED 
             THAT THERE ARE NOW NO APPLICATION CONNECTIONS AVAILABLE. 
             THE PATH IS THEN ABORTED,  CAUSING THE INITIATOR TO RECEIVE
             A *CONNECTION BROKEN* INSTEAD OF A *CONNECTION REJECTED* 
             INDICATION.
          2. IF NDR STATUS IS CALLED MORE FREQUENTLY THAN *REMCONR* CAN 
             PROCESS INCOMING CONNECTS, THE SAME CONNECT REQUEST WILL BE
             QUEUED MORE THAN ONCE ON THE CONNECTION REQUEST QUEUE, 
             SINCE NDR ONLY CHECKS THE HEAD OF THE CONNECTION REQUEST 
             QUEUE IN THE NAD.  THIS CAN CAUSE UNNECESSARY OVERHEAD IN
             RHF AND NDR IF REQUESTS ARE MADE FOR NON-EXISTANT CONNECTS.
          SOLUTIONS - 
          1. MODIFY *REMCONR* TO PROCESS ONLY ONE CONNECT PER CALL. 
          2. MODIFY *STATCMP* TO ONLY QUEUE AN INCOMING CONNECT IF
             THE QUEUE IS EMPTY.
          GSA/NAD            05/29/84       REMCONR,STATCMP 
  
 RHFA890  THIS PSR FIXES A LOGIC ERROR IN THE RCFGEN LNAD MACRO 
          CODE CONVERSION ALLOCATION PARAMETERS.  THE CURRENT 
          CODE IS MAKING CHARACTER COMPARES WHICH MEANS THAT
          SINGLE DIGIT NUMBERS GREATER THAN SIX ARE REJECTED. 
          THE NEW CODE CONVERTS THE INPUT NUMBERS BEFORE MAKING 
          VALIDITY CHECKS TO ALLOW SINGLE DIGIT VALUES TO BE ENTERED. 
          NAD/GSA 06/18/84         RCFGEN 
  
 RHFA891  THIS PSR FIXES A PROBLEM IN RHF PP UTILITY ROUTINE
          RHH.  THE PROBLEM IS THAT RHH IS COMPARING BYTE 5 OF
          THE FNT ENTRY WHEN SEARCHING FOR EXISTING FNTS. 
          THE SYMPTOM OF THIS PROBLEM IS THAT RHH COULD 
          MISTAKENLY GENERATE A DUPLICATE FNT.
          CDF/GSA 06/18/84         RHH
  
 RHF0148  THE FOLLOWING FIX GOES INTO NDR TO MAKE SURE THAT NDR 
          ALWAYS RELEASES FIELD ACCESS BEFORE ATTEMPTING TO RESERVE 
          THE CHANNEL.  ALSO A FIX IS ADDED TO NDR TO MAKE SURE 
          FIELD ACCESS IS RESERVED IN THE WRITE CONVERT MODE UPDATE 
          OUT POINTER ROUTINE.
          GSA    06/04/84          NDR
  
 RHFA968  PROBLEM: WHEN A BLOCK ERROR IS DETECTED BY THE NAD
          CONTROLWARE DURING NAD CODE CONVERSION, NDR OVERLAY 
          4NB INCORRECTLY REPORTS *UNKNOWN BLOCK ERROR*.
          SOLUTION: CORRECT TEST IN 4NB TO DETECT CONVERT MODE
          BLOCK ERRORS SO THAT NAD PATH STATUS WILL BE TAKEN. 
          NAD    07/25/84    NDR
  
*L627*  *********************************************************************** 
  
 F5939L1  RHF RAM ENHANCEMENTS, PHASE 1 (AUTOMATIC DUMPING AND
          RELOADING OF LOCAL NADS AFTER FAILURE). 
  
          RCFGEN - ADD PARAMETERS TO LNAD/RNAD MACROS (AUTODUMP/LOAD, 
                   CWNAM,CWTYP) 
                 - LOCAL/REMOTE NAD ENTRY LENGTH = 5/4 WORDS
                 - ENSURE MHF APPLICATION IS DEFINED
          RHF    - CALL MHF IF LOCAL NAD TURNED OFF BY NDR
          MHF    - DUMP AND RELOAD LOCAL NAD
  
            PL1L DECKS MODIFIED - (* = COMMON DECK) 
             *COMRFLSH *COMRNET *COMRRTN  RCFGEN   RHH      SUPRMSG 
             *COMRNAM  *COMRQUE  NADOFF   RHFOVL
            PL1L DECKS ADDED - (* = COMMON DECK)
              ATTFIL  *COMMGET  GETCWIP  MHF      RECNAD   WEOR17 
              CALLCVL  DBGNAME  GETNCW   MHFMSG   SETCWIP  WEOR18 
              CALLMHF  DUMPNM   GETNDT   NADDUMP  SETNDT
              CALLNLD  FINDCW   GETSUPM  NADLOAD  SYSCALL 
             *COMMCOM  FSNADW   LOADCW   PUTNDTM  WEOR16
  
          DPK    08/28/84          COMRFLSH,COMRNAM,COMRNET,COMRQUE,
                                   COMRQUE,NADOFF,RCFGEN,RHFOVL,RHH,
                                   SUPRMSG, 
                                   ATTFIL,CALLCVL,CALLMHF,CALLNLD,
                                   COMMCOM,COMMGET,DBGNAME,DUMPNM,
                                   FINDCW,FSNADW,GETCWIP,GETNCW,
                                   GETNDT,GETSUPM,LOADCW,MHF,MHFMSG,
                                   NADDUMP,NADLOAD,PUTNDTM,RECNAD,
                                   SETCWIP,SETNDT,SYSCALL,WEOR16, 
                                   WEOR17,WEOR18
  
 RHFB115  MODIFY FIP NETXFR TO RETRY NETPUT OF LEVEL 7 COMMANDS 
          UNTIL TIMEOUT EXPIRES IF FC/NAK RECEIVED. 
          NAD    09/18/84          COMADEF,CHKTIME,PRNAKM 
  
 RHFTXTS  MODIFY RHF PL TO USE SYMPL TEXTS. 
          NAD    09/21/84          FIP,RHF,NETLOG (MANY)
  
 C5939L1  LOGRNAD (NETLOG) AND RCFGEN USE CORRECT NAD ENTRY LENGTH. 
          MHFMSG (RHF) SENDS CORRECT NAD ENTRY TO MHF.
          LOADCW, SETCWIP (MHF) SET NAD INITIALIZATION PARAMETERS 
                 CORRECTLY, TO ALLOW FOR NAD-CODE-CONVERSION BUFFERS. 
          DPK    10/10/84            LOADCW,LOGRNAD,MHFMSG,RCFGEN,
                                     SETCWIP
  
 RHFB138  SUPPORT PATH-RELATED CONTROL MESSAGES AS FOLLOWS: 
          MODIFY NDR TO OBTAIN PATH NUMBER FROM LOCAL PATH ID 
          FIELD INSTEAD OF FROM NAME FIELD FOR INCOMING CONTROL 
          MESSAGES;  DO NOT ATTEMPT TO DELETE STRAY CONTROL 
          MESSAGES BY NAME WHEN ESTABLISHING OR PURGING A PATH. 
          DJR/NAD  11/20/84        NDR
  
 RHFB139  NETLOG WAS NOT CORRECTLY SENDING THE ENTIRE NAD ERROR LOG 
          TO THE NOS/BE CERFILE.  THE CODE PREVENTS ROUTINE LOG$CER 
          FROM GARBLING THE SECOND 60-BITS OF EVERY 5TH ENTRY WITHIN
          THE NAD ERROR LOG.
          DPK    11/20/84          LOG$CER
  
 F5939L2  RHF RAM ENHANCEMENTS, PHASE 2.
          MHF ACCEPTS NEW ERROR RESPONSES FROM NLD, AND 
                SENDS NEW DAYFILE MESSAGES. 
          NDR/NLD DETECT PROCESSOR-STOPPED AND CONNECTION ERRORS, 
                RETURN NEW ERROR RESPONSES TO CALLER (MHF/RHF), AND 
                SEND NEW MESSAGES TO BML/CERFILE. 
          RCFGEN LOCAL NAD DEFAULTS, AUTODUMP/LOAD = YES, CWTYPE = 170. 
          RHF ACCEPTS NEW ERROR RESPONSES FROM NDR, AND SENDS NEW 
                DAYFILE MESSAGES. 
              MESSAGE REVISED - *RHF, MHF APPLICATION DISABLED...*
              SETS LOCAL NAD STATE = LOAD-REQUIRED TO MAKE MHF PERFORM
                INITIAL C/W LOADING (INSTEAD OF BCPROC OR LOADBC).
              SETS LOCAL NAD STATE = AVAILABLE WHEN EST ENTRY TURNS ON. 
  
          PURGED DECKS - COMNADCER. 
          ADDED DECKS - COMNCER,COMNCES.ERRNLD. 
  
          DPK    11/20/84          AUTLOAD,CALLCVL,CKESTAT,COMMCOM, 
          KEK                      COMNCER,COMNCES,DUMPNM,ERRNLD, 
          DJR                      FSNADW,IDLE,LOADCW,MHF,MHFMSG,NDR, 
          NAD                      NLD,RCFGEN,RHFOVL,STATEVT,STATUSF, 
                                   SYSCALL,5CV
  
 RHFB143  IMPROVE NETXFR FILE TRANSFER PERFORMANCE ON NOS/BE
          BY USING THE DEFAULT CPU RECALL PERIOD RATHER THAN
          THE MAXIMUM OF 3777B. 
          NAD    11/29/84          COMADEF (RHFWAIT,RHFXFR,XFRCOMP) 
  
 RHF0150  PROBLEM:  NETXFR SOMETIMES INCORRECTLY INSERTS OR MISPLACES 
            SECTION OR PARTITION (SYSTEM LOGICAL RECORD) BOUNDARIES,
            PARTICULARLY WHEN READING FROM TAPE.
          SOLUTION:  ELIMINATE A RACE CONDITION IN NETXFR MODULE
            *MOREIN* WHICH ALLOWED NETXFR TO ASSUME AN EMPTY BUFFER 
            CONDITION WHEN THE INPUT DRIVER (CIO OR NDR) WAS STILL
            WORKING ON THE FET. 
          GSA/NAD  11/29/84        MOREIN 
  
 RHFB130  PROBLEM:  WHEN FIP NETXFR IS RECEIVING A FILE USING NAD 
            CODE CONVERSION AND THE SENDING SIDE TERMINATES THE FILE
            TRANSFER BY SENDING AN *ES* COMMAND WITHOUT AN EOI PRU BLOCK, 
            NETXFR HANGS UNTIL TRANSFER TIMEOUT.  THIS IS SEEN
            PRIMARILY WITH CY200 OR IBM RHF REMOTE HOSTS. 
          SOLUTION:  CORRECT FIP MODULE *RHFERRC* TO ALWAYS FORCE AN *EOI*
            CONDITION WHEN NDR REPORTS THE NEXT BLOCK IS NOT A PRU BLOCK. 
            NETXFR WILL ATTEMPT TO NETGET THE BLOCK AFTER CONVERT MODE
            HAS BEEN EXITED.
          NAD    12/02/84          RHFERRC
  
 RHF0231  PROBLEM:  IF 170 RHF APPLICATION REQUESTS AN FC/BRK 
                 SUPERVISORY MESSAGE TO BE SENT, THE BLOCK TYPE 
                 FIELD IN THE CONTROL MESSAGE SENT BY RHF CONTAINS
                 ZERO RATHER THAN THAN FOUR (COMMAND BLOCK).  IBM 
                 RHF DIAGNOSES THIS AS AN INVALID SUPERVISORY 
                 MESSAGE. 
          SOLUTION:  CORRECT FIELD DEFINITION IN *COMRQUE*. 
          NAD    12/06/84          COMRQUE (FCBRKR, FCRSTR) 
  
 C5939L2  RHF RAM ENHANCEMENTS, PART 2. 
          RHF STARTUP AND SHUTDOWN PROCESSING REVISED.
          RCFGEN GENERATES CONFIGURATION-FILE RECORD WITH 77 AND 50 
              TABLES, WHICH SHOW UP ON ITEMIZE LIST.
            ACCEPTS NEW PARAMETERS - *RN* SPECIFIES NAME OF RECORD IN 
              77 TABLE (DEFAULT IS *RCFXXX*, XXX IS HOST PID), *LO* 
              CONTROLS COMPASS LIST OPTIONS.
            SAVES COMMENTS FROM RCFGEN CONTROL STATEMENT IN 77 TABLE. 
            LISTS NO INTERNAL MACROS OR DATA STATEMENTS BY DEFAULT. 
            DETECTS MISSING *APPL*, *NPID*, OR *LNAD* DIRECTIVES. 
          ALLOW RHF CONFIGURATION RECORD NAME TO BE SPECIFED ON 
            RHF CONTROL STATEMENT.  *RHF,RN=ABCDEFG.* WILL SEARCH 
            *RCFILE*, *RCFXXX*, AND *SYSTEM* FOR RECORD NAME
            *ABCDEFG*.
          RHF DISPLAYS DATE, TIME, AND COMMENTS FROM CONFIGURATION- 
            FILE RECORD.
          RHF CHECKS CONFIGURATION-FILE VERSION INFORMATION.
          SEARCH SYSTEM LIBRARY FOR RHF CONFIGURATION RECORD IF 
            NOT FOUND ON LFN *RCFILE* OR PFN *RCFXXX*.
          RHF (UPDNWS) CORRECTLY UPDATES NOS LID TABLE STATUS IF
            MORE THAN ONE LOCAL NAD.
          RHF (AGENTON) SENDS MESSAGE IF SPUN OFF APPLICATION JOB 
            FAILS TO NETON AFTER WITHIN 300 SECONDS.
          RHF (MHFMSG) DOES NOT START MHF IF PREVIOUSLY STARTED.
          ADD RHF VERSION NUMBER AND PSR LEVEL MESSAGE. 
          RHF NOW CHECKS THE SUBSYSTEM IDLE FLAG IN RA+0 (NOS). 
          MODIFY DEFAULT RHF SPOT JOB SKELETON TO SUPPRESS PAUSES 
            AFTER CERTAIN ERROR CONDITIONS. 
          MHF (ERRNLD) MESSAGE FOR NLD ERROR 4 CHANGED. 
          MHF (RECNAD) LOADS NAD IF AUTODUMP DISABLED, AS LONG AS 
            AUTOLOAD IS ENABLED.
          NAD    12/10/84          COMRNET,COMRLRA,COMRMEM,COMRPTRS 
          DPK                      RHFDATA,CONTROL,STARTUP,CLEANUP
                                   CLRSCP(NEW),DUMPFL,ENDRHF(NEW),IDLE
                                   ACTIVE,MHFMSG,UPDNWS,FALTNAD(PURGED) 
                                   AGENTON,GETFILE(PURGED),GETRCF(NEW)
                                   MOVE(NEW),RHFOVL,RCFGEN,ERRNLD,RECNAD
                                   CHCMD,YZTB(NEW)
  
 C5939M2  RHF RAM ENHANCEMENTS, PART 2. 
          MHF (GETCWIP) IMPROVED SEARCH OF CONFIGURATION FILE FOR 
            C/W INITIALIZATION PARAMETER RECORD.
          NDR PUTS LOCAL TCU ENABLES IN BML CONNECTION ERROR MESSAGE, 
            AND LOCAL NAD ADDR AND TCU ENABLES IN CERFILE CONNECTION
            ERROR MESSAGE.
          DPK    12/19/84          COMNCES,GETCWIP,NDR,STARTUP
  
*L630*  *********************************************************************** 
  
 C5939N2  CYBER 170 RHF RAM PHASE 2 FEATURE CORRECTION. 
          RHF (MHFMSG) - DOES NOT TRY TO START MHF IF 
             IDLE-DOWN OR SHUT-DOWN.
          MHF (MHF) - DOES NOT ABORT AFTER NETON REJECTED 
             UNLESS ERROR IS INVALID OR INDICATES INVALID 
             ACN SPECIFIED. 
  
          ADDED DECKS --- 
          WEOR19 (END OF RECORD)
          LISTNAD PROCEDURE - LIST NAD DUMP(S) FROM BINARY FILE.
  
          DPK    01/30/85          MHF,MHFMSG,COMMCOM,WEOR19,LISTNAD
  
*L642*  *********************************************************************** 
  
 RHFA327  PROBLEM: THE PARAMETER NAME WAS DOCUMENTED AS 
          BEING REQUIRED BUT THE CODE DID NOT ENFORCE THIS. 
          CAUSE: NO CHECK WAS BEING MADE. 
          SOLUTION: MAKE SURE THAT IT WAS SPECIFIED.
          MLB    02/13/85    RCFGEN 
  
 RHFA329  PROBLEM: THE MXCONS PARAMETER COULD BE SPECIFIED AS 0.
          SOLUTION: ALLOW ONLY VALUES ABOVE ZERO. 
          MLB    02/13/85    RCFGEN 
  
 RHFA334  PROBLEM: THE LENGTH OF THE PID AND LID PARAMETERS WAS 
          DOCUMENTED AS 3 CHARACTERS, BUT THE CODE DID NOT ENFORCE THIS.
          SOLUTION: IF THE LID OR PID IS SPECIFIED WITH LENGTH.NE.3 THEN
          GIVE AN ERROR.
          MLB    02/13/85    RCFGEN 
  
 RHFA336  PROBLEM: MXCOPYS AND MXCONS WERE DOCUMENTED WITH A
          MAXIMUM OF 127 BUT THE CODE DID NOT ENFORCE THIS AND SO ANY 
          VALUE COULD BE SPECIFIED. 
          SOLUTION: CHECK THAT THE SPECIFIED VALUE IS LESS THAN 128.
          MLB    02/13/85 
  
 RHFA352  PROBLEM: RANGE CHECKING WAS NOT PERFORMED ON MAXNDRS. 
          SOLUTION: DO RANGE CHECKING.
          MLB    02/13/85    RCFGEN 
  
 RHFB168  MHF CORRECTED TO PREVENT ABORT WHEN REQUESTING MAINTENANCE
          ACCESS TO A NAD ON CHANNEL 0  (ERROR MESSAGE - *INCORRECT 
          PARAMETER COMBINATION*).
  
          DPK    02/26/85          CALLCVL
 F5939RI  FEATURE MODSET TO REDUCE RHF FIELD LENGTH IF THERE ARE
          NO ACTIVE CONNECTIONS.  APPLICATION NETWAIT QUEUE ENTRIES 
          ARE ELIMINATED AND THE NETWAIT INFORMATION CONSOLIDATED 
          IN THE APPLICATION TABLE.  IN ADDITION, NDR WILL NOT BE 
          DROPPED WHEN LEAVING THE IDLE STATE BECAUSE AN NDR EVENT
          WAS DETECTED. 
          KEK    04/03/85 
  
 C5939RI  RHF IDLE FEATURE CORRECTIONS. 
          NAD    05/06/85          OVLYSCN,TIMEVNT
  
 RHFB190  PROBLEM - NDR *DISCONNECT PATH* AND *FLUSH PATH*
                 FUNCTIONS ISSUE *ABNORMAL PATH STATUS* FAULT 
                 IF THE PATH HAS ALREADY BEEN PURGED.  ALTHOUGH 
                 THIS SHOULD NOT NORMALLY OCCUR, OTHER NDR
                 FUNCTIONS ALLOW A *NAK* RESPONSE.
          SOLUTION - MODIFY NDR ROUTINE *TRM* TO SKIP *DISCONNECT*
                 AND *PURGE* FUNCTIONS IF *SELECT PATH* RETURNS 
                 A *NAK*. 
          NAD    04/28/85    NDR
  
 RHF0101  PROBLEM - FIELDS GETTING TRUNCATED ON THE APPLICATION AND THE 
          ID RHF L-DISPLAYS ON NOS/BE (ON NOS THE APPLICATION K-DISPLAY)
          SOLUTION - ENLARGE THE FIELDS SO THAT NO TRUNCATION OCCURS. 
          DJR    04/26/85    RHF0101 - HISTORY
                                       APPLDSPL 
                                       IDDSPL 
  
 RHF0263  SYMPTOM - LINES GETTING LOST ON THE 721 CONSOLE 
          PROBLEM - SPACING OF THE ROWS ON THE RHF K-DISPLAY ON NOS IS
          TOO NARROW FOR DISPLAY ON THE 721 CONSOLE 
          SOLUTION - INCREASE THE SPACING BETWEEN ROWS IN THE K-DISPLAY 
          TO THAT RECOMMENDED FOR THE 721 CONSOLE.
          DJR    04/26/85    RHF0263  - HISTORY 
                                        APPLDSPL
                                        IDDSPL
                                        PATHDSPL
                                        COMRDSDL
  
 RHFB182  SYMPTOM - WHEN DOING A REMOTE DUMP THRU *DMPNAD*, *NLD* 
          RETURNS AN ERROR CODE 4, WHICH CAUSES THE LOCAL *NAD* TO
          BE TURNED OFF.
          PROBLEM - TWO PROBLEMS CAUSE THIS SYMPTOM, FIRST WHEN *NLD* 
          TRIES TO READ THE PATH CONTROL TABLE TO CHECK FOR A 
          DISCONNECT RECEIVED FOR REMOTE *NAD*, *NLD* ONLY TRIES TO 
          READ 2 WORDS OF THE TABLE WITH A BINARY INPUT WHICH CAUSES
          AN ASSEMBLY/DISASSEMBLY ERROR FROM THE *NAD*.  SECOND, IF A 
          *PATH ABORTED* STATUS IS RETURNED IN RESPONSE TO A READ DATA
          FUNCTION, IT IS TREATED AS AN ERROR, RATHER THAN AN END-OF-DATA 
          INDICATOR.
          SOLUTION - READ THE PATH CONTROL TABLE IN 8/12 MODE USING 
          THE PROPER SYMBOLS.  ALSO HAVE *NLD* CHECK FOR A REMOTE 
          DISCONNECT IF ABORTED DURING A READ DATA BLOCK FUNCTION.
          DJR    05/02/85          NLD
  
 PSRLEVA  MOVE RHFVER AND RHFPSR DEFINITIONS TO COMCBEGN ON RHC.
          NAD    07/16/85          STARTUP
  
 RHFB215  UPDATE THE COMNCER TO USE THE NEW MONITOR SEQM SUBFUNCTION (2)
          TO TURN OFF A REMOTE NAD IN THE EST.
          DJR    07/16/85    COMNCER
  
 RHFA915  SYMPTOMS - ON THE 721 CONSOLE THE HEADER OF THE PATH DISPLAY
          (THE ORD FIELD) IS OVERWRITTEN BY 2 BLANKS. 
          PROBLEM - WHEN BLANKS ARE PUT IN (ON NOS) TO SKIP OVER THE
          WORD COUNT AND SIZE FIELDS OF NOS/BE, THESE BECOME PART OF
          THE HEADER LINE.  ON THE DISPLAY CONSOLE THESE ARE IGNORED, 
          BUT ON THE 721 CONSOLE, THESE WILL WRAP AROUND ON THE SCREEN
          THUS BLANKING OUT THE FIRST TWO CHARACTERS OF THE CURRENT 
          LINE. 
          SOLUTION - PAD OUT THIS FIELD WITH DATA WHICH IS HARMLESS TO
          BOTH THE DISPLAY CONSOLE AND THE 721 CONSOLE.  THE PADDING
          CHOSEN IS 6000B, WHICH WOULD REPOSITION THE X COORDINATE. 
          THIS COORDINATE WILL GET RESET BEFORE ANY DATA IS PUT ON THE
          SCREEN. 
          DJR    07/22/85          PATHDSPL 
  
 F5939DN  MODIFY *DMPNAD* (I= OPTION) TO RECOGNIZE DUMP RECORDS WITH
            PREFIX (77) TABLE, AND PRINT DATE, TIME, AND COMMENTS.
            (PROCESS UNPREFIXED (OLD-FORMAT) RECORDS AS WELL.)
            USE JOB DEFAULT PAGE LENGTH AND PRINT DENSITY (GETPAGE).
          MODIFY *MHF* TO ADD PREFIX (77) TABLE TO NAD BINARY DUMP
            RECORD TO INDICATE DATE AND TIME OF DUMP, AND NAD CHANNEL 
            NUMBER. (THIS APPEARS IN DMPNAD AND ITEMIZE OUTPUT).
          NAD    07/31/85          COMMCOM,DMPNAD,DUMPNM,SYSCALL
          DPK 
  
*L650*  *********************************************************************** 
  
 RHF0074  PROBLEM - IF RHF CANNOT ASSIGN A FET I/O REQUEST TO 
                 AN NDR (FOR EXAMPLE, CONNECTION IS BROKEN),
                 THE UCP CAN ABORT WITH *HUNG IN AUTO-RECALL*.
          SOLUTION - MODIFY ROUTINE REQUECS TO INITATIATE 
                 AN NSUP REPLY FOR FET I/O REQUESTS SO THAT 
                 THE FET COMPLETE BIT WILL BE SET.
                 MODIFY FIP NETXFR ROUTINE XFRCOMP TO USE 
                 AUTO-RECALL TO WAIT FOR RHF FET I/O COMPLETE.
          NAD    09/18/85   RHF    XFRCOMP,REQUECS
  
 RHF0102  PROBLEM - IF AN APPLICATION ISSUES A CON/ACRQ/R SUPERVISORY 
                 MESSAGE TO RHF WITH A NON-ZERO PID AND A ZERO LID, 
                 THE CONNECTION IS REJECTED BY THE REMOTE HOST WITH 
                 *PID/LID NOT AVAILABLE* MESSAGE. 
          SOLUTION - CORRECT CODE IN ROUTINE BLDRMSG TO PROPERLY STORE
                 THE REQUESTED PID IN THE LID FIELD IN THIS CASE. 
          NAD    09/16/85   RHF    BLDRMSG
  
 RHF0179  PROBLEM - RHH GETS MANY ASSEMBLY ERRORS ON NOS/BE IF ASSEMBLED
                 WITH IPTEXT. 
          SOLUTION - SUPPLY MISSING LINE COUNT ON *IF* DIRECTIVE. 
          NAD    09/16/85   RHF    RHH
  
 RHF0288  SYMPTOM - NDR CAN LOOP ON FET I/O (NETUXFR) REQUESTS
                 FOR 8/12 ASCII *READ*. 
          PROBLEM - NDR NOT CLEARING OUT *REMWORDS* BETWEEN 
                 APPLICATION BLOCKS.
          SOLUTION - HAVE NDR CLEAR OUT *REMWORDS* WHEN IT BETWEEN
                 APPLICATION BLOCKS.
          DJR    09/29/85    RHF   NDR
  
 RHF0289  PROBLEM - IF AN ERROR OCCURS DURING A FET I/O (NETUXFR) 
                 REQUEST FOR 8/12 ASCII *READ*, AN INCORRECT JUMP 
                 IN NDR COULD CAUSE INCORRECT ERROR INDICATIONS.
          SOLUTION - CORRECT THE JUMP IN NDR. 
          DJR    09/29/85    RHF   COM2NQ 
  
 RHFB234  PROBLEM:  RHC COMMON DECK CMMINT ENTRY POINTS CMMALF AND
                 CMMAGR CONFLICT WITH THE STANDARD SYMLIB CMM 
                 INTERFACES.
          SOLUTION: MODIFY RHF/RHP/ITF COMPONENTS TO USE STANDARD 
                 INTERFACE;  REMOVE CMMINT FROM RHC AND LCNLIB. 
          NAD    11/09/85   RHF (RHFB234A) - CALLCC,GMEMCMM,XFRINIT,MHF 
                            RHP (RHFB234B) - QTF (MANY), CALL$CC
                            ITF (RHFB234C) - BLKGET 
                            RHC (RHFB234D) - CMMINT (PURGED)
  
 F0095A   NETXFR (FIP) ERROR PROCESSING IMPROVEMENTS: 
          NETXFR COMPLETES TRANSFER PROTOCOL IF CIO ERROR (DEVICE FULL/ 
            UNRECOVERED PARITY/TAPE BLOCK SIZE ERROR), OR IF RHF I/O
            ERROR, OR IF SYSTEM ERROR (PP ABORT, OPERATOR DROP, 
            I/O LIMIT, M/S LIMIT, OR CP-TIME LIMIT).
          NETXFR REQUESTS LOCAL FILE-OPEN AT THE SAME TIME AS IT EITHER 
            SENDS THE SS-COMMAND (SEND-FILE), OR WAITS FOR THE
            SS-COMMAND (RECEIVE-FILE).
          NETDBG PRINTS NETGET/PUT DATA IN HEX AND OCTAL. 
          RHH FUNCTION 7 SETS OR CLEARS THE FORCE-EXIT-PROCESSING FLAG
            FOR FTFS (NOS/BE ONLY). 
  
          DECKS ADDED: BINCHF, FIPRPV, QUITXFR, SETFTTA.
                       (BINCHF ENTRY POINTS - DECCHF,HEXCHF,OCTCHF) 
          DECKS REMOVED: OCTCHF,OCTCHAR,SEFCDF. 
  
            IDENT     PL           DECKS
            ------    -----------  ---------- 
            F0095A    PL1L/REL16A  (SEE BELOW)
            F0095B    PL91/REL16B  COMCPTF,COMDXFR,COMPSER,COMPTFS,FTFS,
                                   MFLINK,MFLSKEL,PFSRPV,PTFS,PTERXF, 
                                   PTFSKEL,QFSSKEL,QTFSKEL,RCM04,XFRERR 
  
          DPK    11/12/85          COMACBX,COMADEF,COMADFM,COMAFET, 
                                   RHFXFR,RHFXFRC,BINCHF,BLDTRT,
                                   BUILDFT,CALLCIO,CALLRHF,CHASE, 
                                   CHKFTT,CHKTIME,CIOERRC,DAYFMSG,
                                   DBGMSG,DFTTIND,DODPR,ENDXFR,EXITCM,
                                   FIPRPV,GETLEV7,INITIME,INREQ,OUTREQ, 
                                   PENDACK,PENDXFR,PLEV7M,PRACKM,PRASM, 
                                   PRNAKM,PROTERR,PRQUIT,PSCMREP, 
                                   PUTLEV7,QUITXFR,RBLDFET,RHFERRC,RHH, 
                                   SETFTTA,SELCM,VALLOCF,XFRCOMP,XFRINIT
  
 F0297A   ENHANCE FIP NETXFR FOR NOS/BE TO NOS/BE *UH* DISK TRANSFERS TO
                 SEND THE RANDOM ATTRIBUTE VALUE IN THE CONTROL WORD
                 OF THE FIRST PRU.
  
          **CAUTION** - THIS MODSET IS DEPENDENT ON MODSET NB0E527 TO 
                 1OP ON NOS/BE PL1A, WHICH ALLOWS A PROGRAM TO DETERMINE
                 WHETHER A FILE HAS THE RANDOM ATTRIBUTE WITHOUT
                 ATTEMPTING TO READ THE FILE INDEX. 
  
          NAD    09/30/85   RHF    COMADEF,COMACBX,COMAFET
                                   BLDTRT,OUTREQ,VALLOCF,XFRINIT
  
 RHFB230  DMPNAD ON NOS/BE ABORTS WITH *GETPAGE* AUTO-RECALL ERROR. 
          CORRECTIVE CODE CLEARS REPLY WORD BEFORE DOING *GETPAGE*. 
          DPK    10/22/85          DMPNAD 
  
 C0095AA  PROBLEM - MFLINK CAN HANG INDEFINITELY IN *RHFXFR*, IF THE
            CONNECTION BREAKS DURING TRANSFER INITIATION AND THE RHF
            FET IS BUSY.
          SOLUTION - SET THE COMPLETE FLAG WHEN BUILDING RHF FET. 
          DPK    12/02/85          BLDTRT,BUILDFT 
  
 RHF0090  PROBLEM - NETXFR LEAVES THE LOCAL FILE REWOUND OR AT
            END-OF-INFORMATION, DEPENDING ON THE TRANSFER DIRECTION.
          SOLUTION - NETXFR REWINDS THE LOCAL MASS-STORAGE FILE WHEN
            THE TRANSFER COMPLETES.  NOS/BE TAPE FILES ARE NOT REWOUND. 
  
          NOTE: THIS MODSET APPLIES ONLY TO NOS 2 AND NOS/BE SYSTEMS
                AFTER PSR LEVEL 650 (F0095A CODE INSTALLED).
  
          DPK    12/08/85          COMADEF,OUTREQ 
  
 RHFB231  PROBLEM:  1. RHF SUBSYSTEM ABORTS WITH CPU ERROR EXIT.
                    2. ON NOS/BE, AFTER RHF *IDLE* COMMAND, RHF CAN 
                      ABORT WITH SSF ERROR *EXIT - WITH CONNECTIONS*. 
          SOLUTION: 1. ENSURE THAT ANY APPLICATION TABLE ENTRY POINTERS 
                 RETURNED BY NDR IN STATUS FUNCTION REPLY ARE 
                 ADJUSTED WHEN RETURNING FROM *IDLE* TO *ACTIVE*. 
                    2. ENSURE *ACTIVE* DOES NOT EXIT DURING IDLEDOWN
                 UNTIL ALL APPLICATIONS HAVE NETTED OFF.
          NAD    12/07/85   RHF    IDLE, ACTIVE 
  
 RHFB232  QTF ABORT - *CPU ERROR EXIT AT NNNNNN*
          FIP/OUTREQ IS CORRECTED TO AVOID USING AN INTERNAL TABLE THAT 
          MAY HAVE BEEN RELEASED AS FILE TRANSFER TERMINATES, AND THUS
          PREVENT QTF FROM ABORTING.
          DPK    11/20/85          OUTREQ 
  
*L664*  *********************************************************************** 
  
 RHFB241  PROBLEM - NETXFR TERMINATES TRANSFER WITH *DEVICE FULL* IF
            THE NOS/BE SHARED SET IS TEMPORARILY OUT OF SPACE.
          SOLUTION - NETXFR DELAYS A SHORT TIME TO ALLOW NOS/BE TO
            ALLOCATE ADDITIONAL SPACE ON THE SHARED SET.
  
          ** CAUTION ** IDENT F0095A MUST BE INSTALLED ON PL1L. 
  
          DPK    01/15/85          COMADEF,COMACBX,CHKTIME,CIOERRC, 
                                   FIPRPV,PENDXFR,PRACKM,PROTERR, 
                                   PSCMREP,RHFXFR,RHFXFRC 
  
 F5939EO  NDR/NLD/RHH CHANGED FOR NOS 2.5.1 (658) TO REFER TO THE NEW 
            DEVICE STATUS FIELD IN NAD EST ENTRY (BITS 49-48) INSTEAD 
            OF CHECKING EST BIT 23, AS FOLLOWS: 
  
              DEVICE STATUS      NAD     (PREVIOUS) 
              -------------      ---     ---------- 
              0/1 (ON/IDLE)      ON      BIT 23 = 0 (ON)
              2/3 (OFF/DOWN)     OFF     BIT 23 = 1 (OFF) 
  
          NOTE.  THIS CODE DOES NOT AFFECT NOS/BE.
  
          DPK    02/12/86          RHF COMNOSDEF,NDR,NLD,RHH
  
 F5939L3  RHF RAM ENHANCEMENTS, PHASE 3.
          ERROR LOG RETRIEVAL MOVED FROM MLTF/NETLOG TO MHF.
          MHF - ERROR LOG RETRIEVAL FROM LOCAL AND REMOTE NADS. 
                NAD ERROR LOG ENTRIES SORTED BY SEQUENCE NUMBER,
                  AND DUPLICATE ENTRIES DISCARDED.
                NAD DUMP RECORDS WRITTEN TO SINGLE PERM FILE. 
                BUILD PROCEDURE REVISED WITH ADDED SYMPL TEXT DECKS.
                AUTOMATIC DUMP/LOAD OF REMOTE NADS. 
                NAD INITIALIZATION PARAMETER CONSTANTS ADDED. 
          MLTF/NETLOG - PURGED. 
          RCFGEN, COMMCOM - DEFINE EXTRACT-LOCAL-NAD-ERROR-LOG FLAG 
                (RCFGEN DEFAULT = YES) AND LNAD/RNAD *TRACE* OPTIONS. 
          NDR/NLD SET NAD-LOAD-NEEDED IN EST INSTEAD OF TURNING NAD OFF.
          RHH DOES NOT TURN DOWN/ON NOS/BE NAD EST ENTRY OFF. 
          PREVENT DUPLICATE MAINTENANCE LOG ENTRIES FOR LOCAL NAD ERRORS
            BY USING EST NAD-LOAD-NEEDED FLAG AS INTERLOCK. 
          MODIFY NDR TO RETURN NAD DST INFO FOR *INITIALIZE*. 
          DECKS ADDED - CALLRHC, CHKNST, EDITNEL, ELSUB, MEMCMM, NADLOG,
                        TXTMCOM, TXTMGET, TXTMNAM, TXTMNET, TXTMRHH,
                        TXTMRTN, WRITNEL, -MHFS00-, -MSTEXT-. 
          DECKS REPLACED - FSNADW.
          DECKS REMOVED - COMNCOM, COMNGET, -NSTEXT-, TXTNCOM, TXTNGET, 
                          -NLGS00-, NETLOG, GTRHNDT, GTNDTFL, LOGLNAD,
                          LOGRNAD, SENDMES, LOG$CER, LOG$BML, GET$LOG,
                          WEOR14, MLTFPROC, WEOR15. 
  
          DPK/NAD 03/20/86  RHF    COMNADIO,COMNCER,COMNCES,NDR,NLD,RHH,
                                   RHF(MANY),MHF(MANY),RCFGEN,DMPNAD
  
 C5939L3A FEATURE CORRECTIONS FOR F5939L3.
          1) MHF DUMP FILE DEFINED AS PRIVATE (NOS), OR CATALOGED WITH
             READ AND TURNKEY PASSWORDS (NOS/BE). 
          2) NLD RETURNS CODE 8 INSTEAD OF 9 IF LOCAL NAD ERROR.
          3) RCFGEN LOCAL NAD AUTODUMP PARAMETER DEFAULT IS NO. 
          4) LISTNAD PROCEDURE REMOVED. 
          PURGED DECK - LISTNAD 
  
          DPK    04/04/86    RHF   ATTFIL,NLD,RCFGEN
  
 RHF0290  PROBLEM - FIP DOES NOT ALWAYS WRITE ALL CHARACTER DATA
          (C6/C8) ONTO THE LOCAL FILE.
          SOLUTION - ENSURE ALL DATA WRITTEN BEFORE CLOSING FILE. 
          DPK    05/13/86    RHF   OUTREQ 
  
 RHFB271  PROBLEM - WHEN F5939L3 IS INSTALLED AND THE RHF 
          NETWORK DESCRIPTION TABLE IS SHORTER THAN 128 WORDS,
          MHF FAILS IMMEDIATELY WITH THE MESSAGE * MHF, NDT 
          LENGTH CHANGED.*
          SOLUTION - MODIFY GETNDT (MHF) TO RECOGNIZE SMALLER 
          NDTS.  (TEMPORARY FIX - INCREASE SIZE OF NDT.)
          DPK    07/02/86    RHF   GETNDT 
  
*L674*  *********************************************************************** 
  
 RHF0367A CORRECT INCONSISTENT USE OF AIP/FIP *NETXFR* DD VALUES
          FOR UU AND US. (NOTE, THIS DOES NOT AFFECT PTF/QTF
          OPERATION AS AIP/FIP NETXFR CURRENTLY TREAT UU AND US 
          IDENTICALLY.) 
          NAD    8/31/86
                 RHF0367A   RHF    COMADEF,COMACBX,XFRINIT
                 RHF0367B   RHP    DDC
  
 RHFB288  PROBLEM - THE NOS RHF EXECUTIVE TRIES TO LOAD 
          ITS SECONDARY OVERLAYS WITHOUT RECALL.  HOWEVER THE 
          SYSTEM DOES NOT ALLOW THIS AND FORCES RECALL. 
          SOLUTION - USE THE NEWLY CREATED OVERLAY LOAD CALL *LDX*
          TO LOAD THE SECONDARY OVERLAYS (NOS ONLY).  THIS FIX IS 
          DEPENDENT UPON MODSET CPUM152 OF PSR NUMBER NS2F078.
          KPH    10/05/86    OVLLDR 
*L688*  *********************************************************************** 
  
 RHFB292  PROBLEM - RHF WILL NOT EXECUTE WHEN BIT 55 IS LEFT
          SET IN THE EST ENTRY FOR A NAD.  THIS HAPPENS 
          WHEN EITHOR A LEVEL 3 DEADSTART HAS BEEN PERFORMED
          AND A PATH WAS ACTIVE IN THE NAD OR RHF WAS FORCIBLY
          REMOVED FROM THE SYSTEM VIA AN OVERRIDE AND LEFT A PATH 
          ACTIVE IN THE NAD.
          SOLUTION - CORRECTS RHF TO CLEAR THE BIT WHEN RHF IS
          INITIALIZING. 
          KPH    03/26/87    RHF   AUTLOAD
*L700*  *********************************************************************** 
  
 RHF0377  PROBLEM - RHF ERROR MESSAGE MISSPELLED. 
          SOLUTION - CORRECTED (INVALID MINACN/MAXACN ON NETON).
          DPK    06/19/87    RHF   NETONR 
  
 RHFB324  PROBLEM - NETWAIT TREATS TIME DELAY .GE. 2048 SECONDS LIKE
                 NO DELAY.
          SOLUTION - NETWAIT CORRECTED TO HANDLE LARGE TIME VALUES. 
          DPK    12/09/87    RHF   COMRQUE
  
 RHFA872  PROBLEM - RHF CAN GENERATE A CON/ACRQ/A SUPERVISORY MESSAGE 
                 WITH AN INVALID REASON CODE, WHICH CAN PROVOKE FAULTY
                 APPLICATION PROCESSING.
          SOLUTION - RHF MODIFIED TO PROCESS ALL REMOTE REJECT CODES
                 (0-255) AND SEND ONLY VALID REASON CODES (1-6) WITH
                 THE CON/ACRQ/A SUPERVISORY MESSAGE.  (RHF ALSO DAY-
                 FILES THE CODE WITH AN EXPLANATION.) 
          DPK    12/17/87    RHF   ACRQA,STATEVT
  
*L716*  *********************************************************************** 
  
 RHFB317  PROBLEM - NETXFR DOES NOT TERMINATE A FILE PROPERLY WHEN DATA 
                 ENDS ON A PRU BOUNDARY.  (ITEMIZE OF FILE PRODUCES 
                 *EOF WITH DATA*.)
          SOLUTION - NETXFR (FIP) MODIFIED TO ADD A ZERO-LENGTH PRU WHEN
                 LAST PRU IS FULL.
                 NOTE 1. NO ZERO-LENGTH PRU WILL BE ADDED TO FILES SENT 
                 NOS TO NOS OR NBE TO NBE (*EOF WITH DATA PRESERVED). 
                 NOTE 2. FOR PROPER TRANSFERS BETWEEN NOS AND NOS/BE, 
                 UPGRADE THE RHF APPLICATIONS ON BOTH HOSTS.
          DPK    06/13/88    RHF   COMADEF,COMAFET,BLDTRT,CHASE,MOREIN
  
 RHFB331  PROBLEM - MHF CAN REMAIN ACTIVE INSTEAD OF ROLLING OUT WHEN 
                 RETRIEVING ERROR LOGS FROM A FAULTY REMOTE NAD.  (NLD
                 RETRIES INDEFINITELY.) 
          SOLUTION - NLD MODIFIED TO ABANDON THE RETRIEVAL AFTER 2
                 RETRIES.  (MHF TRIES AGAIN ON ITS NEXT CYCLE.) 
          DPK    06/03/88    RHF   NLD
  
*L739*  *********************************************************************** 
  
 RHFB263  PROBLEM - MHF ASSUMES 64-CHARACTER SET WHEN LOADING LOCAL NAD.
          SOLUTION - MHF LOCAL NAD LOADING MODIFIED TO INDICATE THE 
                 SYSTEM CHARACTER SET.
  
                               RA+67B,   NAD I.P.,
                                BIT 59    WORD 24 
                               -------   ---------
                 63-CHAR SET      0       1000(16)
                 64-CHAR SET      1       0000(16)
  
          * * * * * * * * * * * * * * * * * * * * * * * * * * * 
          * NOS/BE NOTE.  DO NOT INSTALL THIS CODE ON SYSTEMS * 
          *   BEFORE PSR LEVEL 650 (NOS/BE 6.7) UNLESS        * 
          *   PSR NB0E531 HAS BEEN INSTALLED ON PL1A.         * 
          * * * * * * * * * * * * * * * * * * * * * * * * * * * 
  
          DPK    10/25/88    RHF   COMMCOM,LOADCW,SYSCALL 
  
 RHF0382A PROBLEM - ACFETCH STOPS CONVERTING A NETWORK MESSAGE WITHOUT
                 WARNING IF IT FINDS 1) A CM WORD OF ZERO (FORMED BY 8
                 OR MORE CONSECUTIVE ASCII NULLS), OR 2) AN ASCII 
                 CHARACTER VALUE ABOVE 172B (7A).  THIS CAN CAUSE SUB-
                 SEQUENT PARAMETER PROCESSING ERRORS, SUCH AS 
                   *APFETCH - ERROR IN VALUE CONVERSION*. 
          SOLUTION - ACFETCH (LV7CALL) MODIFIED TO CONVERT NETWORK MES- 
                 SAGES PROPERLY.  1) CALLER MUST NOW INDICATE THE NUMBER
                 OF CHARACTERS IN THE MESSAGE (*TEXTLEN* PARAMETER).
                   NEW SYMPL CALL:  CMD = ACFETCH(TEXTHDR,TEXTLEN)
                 2) ACFETCH NOW PROCESSES EXACTLY *TEXTLEN* CHARACTERS, 
                 FIRST CHANGING ASCII CHARACTER VALUES 0-377B TO 0-137B,
                 THEN CONVERTING TO CORRESPONDING DISPLAY CODE OR BLANK.
                 ASSOCIATED MODIFICATIONS:  
                   COMCMAC - (COMPASS MACRO DEFINITION). NEW FORMAT IS
                     [TAG]   ACFETCH TEXTHDR,TEXTLEN[,CMD]
                   PLEV7M  - (FIP SUBROUTINE (RHF/NETXFR)), 
                   AREQ, APSTOR, NMSG - (QTF/QTFS SUBROUTINES), 
                   MFLINK, PTFS, FTFS.
  
                   IDENT     PL    DECKS
                   -----     --    -----
                   RHF0382   RHC   COMCMAC,LV7CALL
                   RHF0382B  RHP   APSTOR,AREQ,NMSG,MFLINK,FTFS,PTFS
  
          DPK    11/28/88    RHF   PLEV7M 
  
 RHF0495  PROBLEM - MFLINK/PTFS/QTF/QTFS CAN ABORT (CPU ERROR EXIT - CM 
                 OUT OF RANGE) WHEN PSR RHFB317 IS INSTALLED, BECAUSE 
                 RHFXFR SOMETIMES MISHANDLES END-OF-DATA.  (THE FILE
                 EVENTUALLY TRANSFERS WITHOUT LOSS OF DATA, AT THE COST 
                 OF UNECESSARY RETRIES AND DUMPS.)
          SOLUTION - RHFXFR (FIP) ROUTINE *CHASE* CORRECTED TO CLOSE A
                 TIMING WINDOW (WHICH RHFB317 ENLARGED).
          DPK    03/28/89    RHF   CHASE
  
 RHFB337  PROBLEM - NDR RECALLS CPU TOO OFTEN AT 4X PP SPEED. 
          SOLUTION - NDR IDLE ROUTINE MODIFIED TO RECALL CPU AFTER
                 PROGRESSIVELY LONGER DELAYS, BASED ON PP SPEED.
          DPK    03/14/89    RHF   COMNOSDEF,NDR
  
 RHFB366  PROBLEM - FILE TRANSFERS TO 583X (DAS) DISKS ARE REJECTED 
                 WITH THE MESSAGE *NETXFR ERROR 16 - INCORRECT DEVICE*. 
                 THIS IS BECAUSE THE ROUTINE *VALLOCF* CHECKS FOR A 
                 MASS STORAGE FILE BY CHECKING THAT THE DEVICE MNEMONIC 
                 STARTS WITH A *D*, BUT 583X DEVICES HAVE MNEMONICS 
                 THAT START WITH AN *E*.
          SOLUTION - SINCE THE DEVICE CHECK IS NOT NECESSARY ON *NOS*,
                 ONLY PERFORM THIS CHECK ON *NOS/BE*. 
          PCS    04/05/91    RHF   COMADEF,COMAFET,VALLOCF
  
 *L774*    ************************************************ 
 *L797*    ************************************************ 
 *L803*    ************************************************ 
 *L840*    ************************************************ 
 *L859*    ************************************************ 
  
* 
*         PL1L HISTORY -- COPYRIGHT CONTROL DATA CORPORATION -- 1981
* 
